(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('ng2-charts'), require('@swimlane/ngx-charts'), require('angular-highcharts'), require('highcharts'), require('ng-circle-progress'), require('@ngx-translate/core')) :
    typeof define === 'function' && define.amd ? define('@xdf/graph', ['exports', '@angular/core', '@angular/common', 'ng2-charts', '@swimlane/ngx-charts', 'angular-highcharts', 'highcharts', 'ng-circle-progress', '@ngx-translate/core'], factory) :
    (global = global || self, factory((global.xdf = global.xdf || {}, global.xdf.graph = {}), global.ng.core, global.ng.common, global.ng2Charts, global.ngxCharts, global.angularHighcharts, global.highcharts, global.ngCircleProgress, global.core$1));
}(this, (function (exports, core, common, ng2Charts, ngxCharts, angularHighcharts, highcharts, ngCircleProgress, core$1) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/libraries/ng2-charts/ng2-charts.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Ng2ChartsComponent = /** @class */ (function () {
        function Ng2ChartsComponent() {
        }
        /**
         * @return {?}
         */
        Ng2ChartsComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        Ng2ChartsComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-ng2-charts',
                        template: "<div class=\"row\">\n  <div class=\"col-lg-6\">\n    <xdf-bar-chart></xdf-bar-chart>\n  </div>\n  <div class=\"col-lg-6\">\n    <xdf-pie-chart></xdf-pie-chart>\n  </div>\n</div>\n<div class=\"row\">\n  <div class=\"col-lg-4\">\n    <xdf-radar-chart></xdf-radar-chart>\n  </div>\n  <div class=\"col-lg-4\">\n    <xdf-doughnut-chart></xdf-doughnut-chart>\n  </div>\n  <div class=\"col-lg-4\">\n    <xdf-polar-area-chart></xdf-polar-area-chart>\n  </div>\n</div>",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        Ng2ChartsComponent.ctorParameters = function () { return []; };
        return Ng2ChartsComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/libraries/ng2-charts/pie-chart/pie-chart.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PieChartComponent = /** @class */ (function () {
        function PieChartComponent() {
            // Pie
            this.pieChartLabels = ['Download Sales', 'In-Store Sales', 'Mail Sales'];
            this.pieChartData = [300, 500, 100];
            this.pieChartType = 'pie';
        }
        /**
         * @return {?}
         */
        PieChartComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        // events
        // events
        /**
         * @param {?} e
         * @return {?}
         */
        PieChartComponent.prototype.chartClicked = 
        // events
        /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            console.log(e);
        };
        /**
         * @param {?} e
         * @return {?}
         */
        PieChartComponent.prototype.chartHovered = /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            console.log(e);
        };
        PieChartComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-pie-chart',
                        template: "<div class=\"card\">\n  <div class=\"card-header\">\n    <h5>Pie Chart</h5>\n  </div>\n  <div class=\"card-body\">\n\n    <div class=\"row\">\n      <div class=\"col-12\">\n          <canvas baseChart\n          [data]=\"pieChartData\"\n          [labels]=\"pieChartLabels\"\n          [chartType]=\"pieChartType\"\n          (chartHover)=\"chartHovered($event)\"\n          (chartClick)=\"chartClicked($event)\"></canvas>\n      </div>\n    </div>\n  </div>\n</div> ",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        PieChartComponent.ctorParameters = function () { return []; };
        return PieChartComponent;
    }());
    if (false) {
        /** @type {?} */
        PieChartComponent.prototype.pieChartLabels;
        /** @type {?} */
        PieChartComponent.prototype.pieChartData;
        /** @type {?} */
        PieChartComponent.prototype.pieChartType;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/libraries/ng2-charts/bar-chart/bar-chart.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BarChartComponent = /** @class */ (function () {
        function BarChartComponent() {
            this.barChartOptions = {
                scaleShowVerticalLines: false,
                responsive: true
            };
            this.barChartLabels = ['2006', '2007', '2008', '2009', '2010', '2011', '2012'];
            this.barChartType = 'bar';
            this.barChartLegend = true;
            this.barChartData = [
                { data: [65, 59, 80, 81, 56, 55, 40], label: 'Series A' },
                { data: [28, 48, 40, 19, 86, 27, 90], label: 'Series B' }
            ];
        }
        /**
         * @return {?}
         */
        BarChartComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        // events
        // events
        /**
         * @param {?} e
         * @return {?}
         */
        BarChartComponent.prototype.chartClicked = 
        // events
        /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            console.log(e);
        };
        /**
         * @param {?} e
         * @return {?}
         */
        BarChartComponent.prototype.chartHovered = /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            console.log(e);
        };
        /**
         * @return {?}
         */
        BarChartComponent.prototype.randomize = /**
         * @return {?}
         */
        function () {
            // Only Change 3 values
            /** @type {?} */
            var data = [
                Math.round(Math.random() * 100),
                59,
                80,
                (Math.random() * 100),
                56,
                (Math.random() * 100),
                40
            ];
            /** @type {?} */
            var clone = JSON.parse(JSON.stringify(this.barChartData));
            clone[0].data = data;
            this.barChartData = clone;
            /**
             * (My guess), for Angular to recognize the change in the dataset
             * it has to change the dataset variable directly,
             * so one way around it, is to clone the data, change it and then
             * assign it;
             */
        };
        BarChartComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-bar-chart',
                        template: "<div class=\"card\">\n    <div class=\"card-header\">\n      <a (click)=\"randomize()\" class=\"btn text-secondary float-right\"><i class=\"fa fa-random\"></i></a>\n      <h5>Bar Chart</h5>\n    </div>\n    <div class=\"card-body\">\n  \n      <div class=\"row\">\n        <div class=\"col-12\">\n            <canvas baseChart\n            [datasets]=\"barChartData\"\n            [labels]=\"barChartLabels\"\n            [options]=\"barChartOptions\"\n            [legend]=\"barChartLegend\"\n            [chartType]=\"barChartType\"\n            (chartHover)=\"chartHovered($event)\"\n            (chartClick)=\"chartClicked($event)\"></canvas>\n        </div>\n      </div>\n    </div> \n  </div>",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        BarChartComponent.ctorParameters = function () { return []; };
        return BarChartComponent;
    }());
    if (false) {
        /** @type {?} */
        BarChartComponent.prototype.barChartOptions;
        /** @type {?} */
        BarChartComponent.prototype.barChartLabels;
        /** @type {?} */
        BarChartComponent.prototype.barChartType;
        /** @type {?} */
        BarChartComponent.prototype.barChartLegend;
        /** @type {?} */
        BarChartComponent.prototype.barChartData;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/libraries/ng2-charts/doughnut-chart/doughnut-chart.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DoughnutChartComponent = /** @class */ (function () {
        function DoughnutChartComponent() {
            // Doughnut
            this.doughnutChartLabels = ['Download Sales', 'In-Store Sales', 'Mail-Order Sales'];
            this.doughnutChartData = [350, 450, 100];
            this.doughnutChartType = 'doughnut';
        }
        /**
         * @return {?}
         */
        DoughnutChartComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        // events
        // events
        /**
         * @param {?} e
         * @return {?}
         */
        DoughnutChartComponent.prototype.chartClicked = 
        // events
        /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            console.log(e);
        };
        /**
         * @param {?} e
         * @return {?}
         */
        DoughnutChartComponent.prototype.chartHovered = /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            console.log(e);
        };
        DoughnutChartComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-doughnut-chart',
                        template: "<div class=\"card\">\n    <div class=\"card-header\">\n      <h5>Doughnut Chart</h5>\n    </div>\n    <div class=\"card-body\">\n  \n      <div class=\"row\">\n        <div class=\"col-12\">\n            <canvas baseChart\n              [data]=\"doughnutChartData\"\n              [labels]=\"doughnutChartLabels\"\n              [chartType]=\"doughnutChartType\"\n              (chartHover)=\"chartHovered($event)\"\n              (chartClick)=\"chartClicked($event)\"></canvas>\n        </div>\n      </div>\n    </div> \n  </div>",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        DoughnutChartComponent.ctorParameters = function () { return []; };
        return DoughnutChartComponent;
    }());
    if (false) {
        /** @type {?} */
        DoughnutChartComponent.prototype.doughnutChartLabels;
        /** @type {?} */
        DoughnutChartComponent.prototype.doughnutChartData;
        /** @type {?} */
        DoughnutChartComponent.prototype.doughnutChartType;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/libraries/ng2-charts/polar-area-chart/polar-area-chart.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PolarAreaChartComponent = /** @class */ (function () {
        function PolarAreaChartComponent() {
            // PolarArea
            this.polarAreaChartLabels = ['Download Sales', 'In-Store Sales', 'Mail Sales', 'Telesales', 'Corporate Sales'];
            this.polarAreaChartData = [300, 500, 100, 40, 120];
            this.polarAreaLegend = true;
            this.polarAreaChartType = 'polarArea';
        }
        /**
         * @return {?}
         */
        PolarAreaChartComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        // events
        // events
        /**
         * @param {?} e
         * @return {?}
         */
        PolarAreaChartComponent.prototype.chartClicked = 
        // events
        /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            console.log(e);
        };
        /**
         * @param {?} e
         * @return {?}
         */
        PolarAreaChartComponent.prototype.chartHovered = /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            console.log(e);
        };
        PolarAreaChartComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-polar-area-chart',
                        template: "<div class=\"card\">\n    <div class=\"card-header\">\n      <h5>Polar Area Chart</h5>\n    </div>\n    <div class=\"card-body\">\n  \n      <div class=\"row\">\n        <div class=\"col-12\">\n            <canvas baseChart\n          [data]=\"polarAreaChartData\"\n          [labels]=\"polarAreaChartLabels\"\n          [legend]=\"polarAreaLegend\"\n          [chartType]=\"polarAreaChartType\"\n          (chartHover)=\"chartHovered($event)\"\n          (chartClick)=\"chartClicked($event)\"></canvas>\n        </div>\n      </div>\n    </div> \n  </div>",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        PolarAreaChartComponent.ctorParameters = function () { return []; };
        return PolarAreaChartComponent;
    }());
    if (false) {
        /** @type {?} */
        PolarAreaChartComponent.prototype.polarAreaChartLabels;
        /** @type {?} */
        PolarAreaChartComponent.prototype.polarAreaChartData;
        /** @type {?} */
        PolarAreaChartComponent.prototype.polarAreaLegend;
        /** @type {?} */
        PolarAreaChartComponent.prototype.polarAreaChartType;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/libraries/ng2-charts/radar-chart/radar-chart.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var RadarChartComponent = /** @class */ (function () {
        function RadarChartComponent() {
            // Radar
            this.radarChartLabels = ['Eating', 'Drinking', 'Sleeping', 'Designing', 'Coding', 'Cycling', 'Running'];
            this.radarChartData = [
                { data: [65, 59, 90, 81, 56, 55, 40], label: 'Series A' },
                { data: [28, 48, 40, 19, 96, 27, 100], label: 'Series B' }
            ];
            this.radarChartType = 'radar';
        }
        /**
         * @return {?}
         */
        RadarChartComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        // events
        // events
        /**
         * @param {?} e
         * @return {?}
         */
        RadarChartComponent.prototype.chartClicked = 
        // events
        /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            console.log(e);
        };
        /**
         * @param {?} e
         * @return {?}
         */
        RadarChartComponent.prototype.chartHovered = /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            console.log(e);
        };
        RadarChartComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-radar-chart',
                        template: "<div class=\"card\">\n    <div class=\"card-header\">\n      <h5>Radar Chart</h5>\n    </div>\n    <div class=\"card-body\">\n  \n      <div class=\"row\">\n        <div class=\"col-12\">\n            <canvas baseChart\n          [datasets]=\"radarChartData\"\n          [labels]=\"radarChartLabels\"\n          [chartType]=\"radarChartType\"\n          (chartHover)=\"chartHovered($event)\"\n          (chartClick)=\"chartClicked($event)\"></canvas>\n        </div>\n      </div>\n    </div> \n  </div>",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        RadarChartComponent.ctorParameters = function () { return []; };
        return RadarChartComponent;
    }());
    if (false) {
        /** @type {?} */
        RadarChartComponent.prototype.radarChartLabels;
        /** @type {?} */
        RadarChartComponent.prototype.radarChartData;
        /** @type {?} */
        RadarChartComponent.prototype.radarChartType;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/libraries/highcharts/highcharts.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var HighchartsComponent = /** @class */ (function () {
        function HighchartsComponent() {
        }
        /**
         * @return {?}
         */
        HighchartsComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        HighchartsComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-highcharts',
                        template: "<div class=\"row\">\n  <div class=\"col-lg-6\">\n    <xdf-high-line-chart></xdf-high-line-chart>\n  </div>\n  <div class=\"col-lg-6\">\n    <xdf-high-pie-chart></xdf-high-pie-chart>\n  </div>\n</div>\n<div class=\"row\">\n  <div class=\"col-lg-6\">\n    <xdf-high-donut-chart></xdf-high-donut-chart>\n  </div>\n  <div class=\"col-lg-6\">\n  </div>\n</div>\n<div class=\"row\">\n  <div class=\"col-lg-12\">\n    <xdf-high-column-line-pie-chart></xdf-high-column-line-pie-chart>\n  </div>\n</div>\n<div class=\"row\">\n  <div class=\"col-lg-12\">\n    <xdf-high-dual-axes-line-column-chart></xdf-high-dual-axes-line-column-chart>\n  </div>\n</div>\n<div class=\"row\">\n  <div class=\"col-lg-12\">\n    <xdf-high-spline-updating-chart></xdf-high-spline-updating-chart>\n  </div>\n</div>\n<div class=\"row\">\n  <div class=\"col-lg-12\">\n    <xdf-high-3d-column-chart></xdf-high-3d-column-chart>\n  </div>\n</div>\n<div class=\"row\">\n  <div class=\"col-lg-12\">\n    <xdf-high-3d-column-group-chart></xdf-high-3d-column-group-chart>\n  </div>\n</div>\n<div class=\"row\">\n    <div class=\"col-lg-6\">\n      <xdf-high-3d-donut-chart></xdf-high-3d-donut-chart>\n    </div>\n    <div class=\"col-lg-6\">\n      <xdf-high-3d-pie-chart></xdf-high-3d-pie-chart>\n    </div>\n  </div>\n\nhttps://www.npmjs.com/package/angular-highcharts",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        HighchartsComponent.ctorParameters = function () { return []; };
        return HighchartsComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/libraries/highcharts/high-line-chart/high-line-chart.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var HighLineChartComponent = /** @class */ (function () {
        function HighLineChartComponent() {
            this.chart = new angularHighcharts.Chart({
                chart: {
                    type: 'line'
                },
                title: {
                    text: 'Linechart'
                },
                credits: {
                    enabled: false
                },
                series: (/** @type {?} */ ([{
                        name: 'Line 1',
                        data: [1, 2, 3]
                    }]))
            });
        }
        /**
         * @return {?}
         */
        HighLineChartComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        // add point to chart serie
        // add point to chart serie
        /**
         * @return {?}
         */
        HighLineChartComponent.prototype.add = 
        // add point to chart serie
        /**
         * @return {?}
         */
        function () {
            this.chart.addPoint(Math.floor(Math.random() * 10));
        };
        HighLineChartComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-high-line-chart',
                        template: "<div class=\"card\">\n    <div class=\"card-header\">\n      <a (click)=\"add()\" class=\"btn text-secondary float-right\"><i class=\"fa fa-plus\"></i></a>\n      <h5>Line Chart</h5>\n    </div>\n    <div class=\"card-body\">\n  \n      <div class=\"row\">\n        <div class=\"col-12\">\n            <div [chart]=\"chart\"></div>\n        </div>\n      </div>\n    </div> \n  </div>  ",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        HighLineChartComponent.ctorParameters = function () { return []; };
        return HighLineChartComponent;
    }());
    if (false) {
        /** @type {?} */
        HighLineChartComponent.prototype.chart;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/libraries/highcharts/high-pie-chart/high-pie-chart.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var HighPieChartComponent = /** @class */ (function () {
        function HighPieChartComponent() {
            this.chart = new angularHighcharts.Chart({
                chart: {
                    type: 'pie'
                },
                title: {
                    text: 'Browser market shares in January, 2018'
                },
                credits: {
                    enabled: false
                },
                plotOptions: {
                    pie: {
                        allowPointSelect: true,
                        cursor: 'pointer',
                        dataLabels: {
                            enabled: false
                        },
                        showInLegend: true
                    }
                },
                series: (/** @type {?} */ ([{
                        name: 'Brands',
                        data: [{
                                name: 'Chrome',
                                y: 61.41,
                                sliced: true,
                                selected: true
                            }, {
                                name: 'Internet Explorer',
                                y: 11.84
                            }, {
                                name: 'Firefox',
                                y: 10.85
                            }, {
                                name: 'Edge',
                                y: 4.67
                            }, {
                                name: 'Safari',
                                y: 4.18
                            }, {
                                name: 'Other',
                                y: 7.05
                            }]
                    }]))
            });
        }
        /**
         * @return {?}
         */
        HighPieChartComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        HighPieChartComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-high-pie-chart',
                        template: "<div class=\"card\">\n    <div class=\"card-header\">\n      <h5>Pie Chart</h5>\n    </div>\n    <div class=\"card-body\">\n  \n      <div class=\"row\">\n        <div class=\"col-12\">\n            <div [chart]=\"chart\"></div> \n        </div>\n      </div>\n    </div> \n  </div>",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        HighPieChartComponent.ctorParameters = function () { return []; };
        return HighPieChartComponent;
    }());
    if (false) {
        /** @type {?} */
        HighPieChartComponent.prototype.chart;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/libraries/highcharts/high-donut-chart/high-donut-chart.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var HighDonutChartComponent = /** @class */ (function () {
        function HighDonutChartComponent() {
            this.chart = new angularHighcharts.Chart({
                chart: {
                    plotBackgroundColor: null,
                    plotBorderWidth: 0,
                    plotShadow: false
                },
                title: {
                    text: 'Browser<br>shares<br>2017',
                    align: 'center',
                    verticalAlign: 'middle',
                    y: 40
                },
                tooltip: {
                    pointFormat: '{series.name}: <b>{point.percentage:.1f}%</b>'
                },
                plotOptions: {
                    pie: {
                        dataLabels: {
                            enabled: true,
                            distance: -50,
                            style: {
                                fontWeight: 'bold',
                                color: 'white'
                            }
                        },
                        startAngle: -90,
                        endAngle: 90,
                        center: ['50%', '75%']
                    }
                },
                series: [{
                        type: 'pie',
                        name: 'Browser share',
                        innerSize: '50%',
                        data: [
                            ['Chrome', 58.9],
                            ['Firefox', 13.29],
                            ['Internet Explorer', 13],
                            ['Edge', 3.78],
                            ['Safari', 3.42],
                            {
                                name: 'Other',
                                y: 7.61,
                                dataLabels: {
                                    enabled: false
                                }
                            }
                        ]
                    }]
            });
        }
        /**
         * @return {?}
         */
        HighDonutChartComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        HighDonutChartComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-high-donut-chart',
                        template: "<div class=\"card\">\n    <div class=\"card-header\">\n      <h5>Donut Chart</h5>\n    </div>\n    <div class=\"card-body\">\n  \n      <div class=\"row\">\n        <div class=\"col-12\">\n            <div [chart]=\"chart\"></div> \n        </div>\n      </div> \n    </div> \n  </div>",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        HighDonutChartComponent.ctorParameters = function () { return []; };
        return HighDonutChartComponent;
    }());
    if (false) {
        /** @type {?} */
        HighDonutChartComponent.prototype.chart;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/libraries/highcharts/high-column-line-pie-chart/high-column-line-pie-chart.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var theme = {
        colors: ['#6ab8f7', '#1bc9b7', '#ffca5b', '#DDDF00', '#24CBE5', '#64E572',
            '#FF9655', '#FFF263', '#6AF9C4'],
        chart: {
            backgroundColor: {
                linearGradient: { x1: 0, x2: 0, y1: 500, y2: 500 },
                stops: [
                    [0, 'rgb(255, 255, 255)'],
                    [1, 'rgb(240, 240, 255)']
                ]
            },
        },
        title: {
            style: {
                color: '#000',
                font: 'bold 16px "Trebuchet MS", Verdana, sans-serif'
            }
        },
        subtitle: {
            style: {
                color: '#666666',
                font: 'bold 12px "Trebuchet MS", Verdana, sans-serif'
            }
        },
        legend: {
            itemStyle: {
                font: '9pt Trebuchet MS, Verdana, sans-serif',
                color: 'black'
            },
            itemHoverStyle: {
                color: 'gray'
            }
        }
    };
    var HighColumnLinePieChartComponent = /** @class */ (function () {
        function HighColumnLinePieChartComponent() {
            this.chart = new angularHighcharts.Chart({
                title: {
                    text: 'Combination chart',
                    style: {
                        display: 'none'
                    }
                },
                xAxis: {
                    categories: ['Apples', 'Oranges', 'Pears', 'Bananas', 'Plums']
                },
                chart: {
                    backgroundColor: 'transparent',
                    height: 310
                },
                // labels: {
                //   items: [{
                //     html: 'Total fruit consumption',
                //     style: {
                //       left: '50px',
                //       top: '18px',
                //       // color: (Highcharts.theme && Highcharts.theme.textColor) || 'black'
                //     }
                //   }]
                // },
                plotOptions: {
                    pie: {
                        center: [100, 80],
                        size: 100,
                        showInLegend: false,
                        dataLabels: {
                            enabled: false
                        }
                    }
                },
                credits: {
                    enabled: false
                },
                series: [{
                        type: 'column',
                        name: 'Jane',
                        data: [3, 2, 1, 3, 4],
                        color: {
                            linearGradient: { x1: 0, x2: 0, y1: 0, y2: 1 },
                            stops: [
                                [0, '#6ab8f7'],
                                [1, '#d6ecfd'] // end
                            ]
                        }
                    }, {
                        type: 'column',
                        name: 'John',
                        data: [2, 3, 5, 7, 6],
                        color: {
                            linearGradient: { x1: 0, x2: 0, y1: 0, y2: 1 },
                            stops: [
                                [0, '#1bc9b7'],
                                [1, '#d6fffb'] // end
                            ]
                        }
                    }, {
                        type: 'column',
                        name: 'Joe',
                        data: [4, 3, 3, 9, 1],
                        color: {
                            linearGradient: { x1: 0, x2: 0, y1: 0, y2: 1 },
                            stops: [
                                [0, '#ffca5b'],
                                [1, '#fff3dc'] // end
                            ]
                        }
                    }, {
                        type: 'spline',
                        name: 'Average',
                        // data: [3, 2.67, 3, 6.33, 3.33]
                        data: [{
                                y: 3,
                                marker: {
                                    lineWidth: 2,
                                    lineColor: highcharts.getOptions().colors[3],
                                    fillColor: 'white'
                                }
                            },
                            {
                                y: 2.67,
                                marker: {
                                    lineWidth: 2,
                                    lineColor: highcharts.getOptions().colors[3],
                                    fillColor: 'white'
                                }
                            },
                            {
                                y: 3,
                                marker: {
                                    lineWidth: 2,
                                    lineColor: highcharts.getOptions().colors[3],
                                    fillColor: 'white'
                                }
                            },
                            {
                                y: 6.33,
                                marker: {
                                    lineWidth: 2,
                                    lineColor: highcharts.getOptions().colors[3],
                                    fillColor: 'white'
                                }
                            },
                            {
                                y: 3.33,
                                marker: {
                                    lineWidth: 2,
                                    lineColor: highcharts.getOptions().colors[3],
                                    fillColor: 'white'
                                }
                            }
                        ]
                    }, {
                        type: 'pie',
                        name: 'Total consumption',
                        data: [{
                                name: 'Jane',
                                y: 13,
                                color: theme.colors[0] // Jane's color
                            }, {
                                name: 'John',
                                y: 23,
                                color: theme.colors[1] // John's color
                            }, {
                                name: 'Joe',
                                y: 19,
                                color: theme.colors[2] // Joe's color
                            }],
                        center: [20, 10],
                        size: 75,
                        showInLegend: false,
                        dataLabels: {
                            enabled: false
                        }
                    }]
            });
        }
        /**
         * @return {?}
         */
        HighColumnLinePieChartComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            highcharts.setOptions(theme);
        };
        HighColumnLinePieChartComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-high-column-line-pie-chart',
                        template: "<div [chart]=\"chart\"></div> \n",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        HighColumnLinePieChartComponent.ctorParameters = function () { return []; };
        return HighColumnLinePieChartComponent;
    }());
    if (false) {
        /** @type {?} */
        HighColumnLinePieChartComponent.prototype.chart;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/libraries/highcharts/high-dual-axes-line-column-chart/high-dual-axes-line-column-chart.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var HighDualAxesLineColumnChartComponent = /** @class */ (function () {
        function HighDualAxesLineColumnChartComponent() {
            this.chart = new angularHighcharts.Chart({
                chart: {
                    zoomType: 'xy'
                },
                title: {
                    text: 'Average Monthly Temperature and Rainfall in Tokyo'
                },
                subtitle: {
                    text: 'Source: WorldClimate.com'
                },
                xAxis: [{
                        categories: ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun',
                            'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'],
                        crosshair: true
                    }],
                yAxis: [{
                        // Primary yAxis
                        labels: {
                            format: '{value}°C',
                            style: {
                                color: highcharts.getOptions().colors[1]
                            }
                        },
                        title: {
                            text: 'Temperature',
                            style: {
                                color: highcharts.getOptions().colors[1]
                            }
                        }
                    }, {
                        // Secondary yAxis
                        title: {
                            text: 'Rainfall',
                            style: {
                                color: highcharts.getOptions().colors[0]
                            }
                        },
                        labels: {
                            format: '{value} mm',
                            style: {
                                color: highcharts.getOptions().colors[0]
                            }
                        },
                        opposite: true
                    }],
                tooltip: {
                    shared: true,
                    pointFormat: '<span style="color:{point.color}">●</span> {series.name}: <b>{point.y}</b><br/>',
                },
                legend: {
                    layout: 'vertical',
                    align: 'left',
                    x: 120,
                    verticalAlign: 'top',
                    y: 100,
                    floating: true
                },
                series: [{
                        name: 'Rainfall',
                        type: 'column',
                        yAxis: 1,
                        data: [49.9, 71.5, 106.4, 129.2, 144.0, 176.0, 135.6, 148.5, 216.4, 194.1, 95.6, 54.4],
                    }, {
                        name: 'Temperature',
                        type: 'spline',
                        data: [7.0, 6.9, 9.5, 14.5, 18.2, 21.5, 25.2, 26.5, 23.3, 18.3, 13.9, 9.6],
                    }]
            });
        }
        /**
         * @return {?}
         */
        HighDualAxesLineColumnChartComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        HighDualAxesLineColumnChartComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-high-dual-axes-line-column-chart',
                        template: "<div class=\"card\">\n  <div class=\"card-header\">\n    <h5>Dual Axes, Line and Column Chart</h5>\n  </div>\n  <div class=\"card-body\">\n\n    <div class=\"row\">\n      <div class=\"col-12\">\n          <div [chart]=\"chart\"></div> \n      </div>\n    </div>\n  </div> \n</div> ",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        HighDualAxesLineColumnChartComponent.ctorParameters = function () { return []; };
        return HighDualAxesLineColumnChartComponent;
    }());
    if (false) {
        /** @type {?} */
        HighDualAxesLineColumnChartComponent.prototype.chart;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/libraries/highcharts/high-spline-updating-chart/high-spline-updating-chart.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var HighSplineUpdatingChartComponent = /** @class */ (function () {
        function HighSplineUpdatingChartComponent() {
            this.chart = new angularHighcharts.Chart({
                chart: {
                    type: 'spline',
                    marginRight: 10,
                    events: {
                        load: (/**
                         * @return {?}
                         */
                        function () {
                            // set up the updating of the chart each second
                            /** @type {?} */
                            var series = this.series[0];
                            setInterval((/**
                             * @return {?}
                             */
                            function () {
                                /** @type {?} */
                                var x = (new Date()).getTime();
                                /** @type {?} */
                                var // current time
                                y = Math.random();
                                series.addPoint([x, y], true, true);
                            }), 1000);
                        })
                    }
                },
                title: {
                    text: 'Live random data'
                },
                xAxis: {
                    type: 'datetime',
                    tickPixelInterval: 150
                },
                yAxis: {
                    title: {
                        text: 'Value'
                    },
                    plotLines: [{
                            value: 0,
                            width: 1,
                            color: '#808080'
                        }]
                },
                tooltip: {
                    formatter: (/**
                     * @return {?}
                     */
                    function () {
                        return '<b>' + this.series.name + '</b><br/>' +
                            highcharts.dateFormat('%Y-%m-%d %H:%M:%S', this.x) + '<br/>' +
                            highcharts.numberFormat(this.y, 2);
                    })
                },
                legend: {
                    enabled: false
                },
                exporting: {
                    enabled: false
                },
                series: (/** @type {?} */ ([{
                        name: 'Random data',
                        data: ((/**
                         * @return {?}
                         */
                        function () {
                            // generate an array of random data
                            /** @type {?} */
                            var data = [];
                            /** @type {?} */
                            var time = (new Date()).getTime();
                            /** @type {?} */
                            var i;
                            for (i = -19; i <= 0; i += 1) {
                                data.push({
                                    x: time + i * 1000,
                                    y: Math.random()
                                });
                            }
                            return data;
                        })())
                    }]))
            });
        }
        /**
         * @return {?}
         */
        HighSplineUpdatingChartComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        HighSplineUpdatingChartComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-high-spline-updating-chart',
                        template: "<div class=\"card\">\n  <div class=\"card-header\">\n    <h5>Spline updating each second    </h5>\n  </div>\n  <div class=\"card-body\">\n\n    <div class=\"row\">\n      <div class=\"col-12\">\n          <div [chart]=\"chart\"></div> \n      </div>\n    </div>\n  </div> \n</div> ",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        HighSplineUpdatingChartComponent.ctorParameters = function () { return []; };
        return HighSplineUpdatingChartComponent;
    }());
    if (false) {
        /** @type {?} */
        HighSplineUpdatingChartComponent.prototype.chart;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/libraries/highcharts/high-3d-column-chart/high-3d-column-chart.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var High3dColumnChartComponent = /** @class */ (function () {
        function High3dColumnChartComponent() {
            this.chart = new angularHighcharts.Chart({
                chart: {
                    type: 'column',
                    options3d: {
                        enabled: true,
                        alpha: 10,
                        beta: 25,
                        depth: 70
                    }
                },
                title: {
                    text: '3D chart with null values'
                },
                subtitle: {
                    text: 'Notice the difference between a 0 value and a null point'
                },
                plotOptions: {
                    column: {
                        depth: 25
                    }
                },
                xAxis: {
                    categories: highcharts.getOptions().lang.shortMonths,
                    labels: {
                        skew3d: true,
                        style: {
                            fontSize: '16px'
                        }
                    }
                },
                yAxis: {
                    title: {
                        text: null
                    }
                },
                series: (/** @type {?} */ ([{
                        name: 'Sales',
                        data: [2, 3, null, 4, 0, 5, 1, 4, 6, 3]
                    }]))
            });
        }
        /**
         * @return {?}
         */
        High3dColumnChartComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        High3dColumnChartComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-high-3d-column-chart',
                        template: "<div [chart]=\"chart\"></div> ",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        High3dColumnChartComponent.ctorParameters = function () { return []; };
        return High3dColumnChartComponent;
    }());
    if (false) {
        /** @type {?} */
        High3dColumnChartComponent.prototype.chart;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/libraries/highcharts/high-3d-column-group-chart/high-3d-column-group-chart.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var High3dColumnGroupChartComponent = /** @class */ (function () {
        function High3dColumnGroupChartComponent() {
            this.chart = new angularHighcharts.Chart({
                chart: {
                    type: 'column',
                    options3d: {
                        enabled: true,
                        alpha: 15,
                        beta: 15,
                        viewDistance: 25,
                        depth: 40
                    }
                },
                title: {
                    text: 'Total fruit consumption, grouped by gender'
                },
                xAxis: {
                    categories: ['Apples', 'Oranges', 'Pears', 'Grapes', 'Bananas'],
                    labels: {
                        skew3d: true,
                        style: {
                            fontSize: '16px'
                        }
                    }
                },
                yAxis: {
                    allowDecimals: false,
                    min: 0,
                    title: {
                        text: 'Number of fruits',
                        skew3d: true
                    }
                },
                tooltip: {
                    headerFormat: '<b>{point.key}</b><br>',
                    pointFormat: '<span style="color:{series.color}">\u25CF</span> {series.name}: {point.y} / {point.stackTotal}'
                },
                plotOptions: {
                    column: {
                        stacking: 'normal',
                        depth: 40
                    }
                },
                series: (/** @type {?} */ ([{
                        name: 'John',
                        data: [5, 3, 4, 7, 2],
                        stack: 'male'
                    }, {
                        name: 'Joe',
                        data: [3, 4, 4, 2, 5],
                        stack: 'male'
                    }, {
                        name: 'Jane',
                        data: [2, 5, 6, 2, 1],
                        stack: 'female'
                    }, {
                        name: 'Janet',
                        data: [3, 0, 4, 4, 3],
                        stack: 'female'
                    }]))
            });
        }
        /**
         * @return {?}
         */
        High3dColumnGroupChartComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        High3dColumnGroupChartComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-high-3d-column-group-chart',
                        template: "<div class=\"card\">\n  <div class=\"card-header\">\n    <h5>3D column with stacking and grouping</h5>\n  </div>\n  <div class=\"card-body\">\n\n    <div class=\"row\">\n      <div class=\"col-12\">\n          <div [chart]=\"chart\"></div> \n      </div>\n    </div>\n  </div> \n</div> ",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        High3dColumnGroupChartComponent.ctorParameters = function () { return []; };
        return High3dColumnGroupChartComponent;
    }());
    if (false) {
        /** @type {?} */
        High3dColumnGroupChartComponent.prototype.chart;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/libraries/highcharts/high-3d-pie-chart/high-3d-pie-chart.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var High3dPieChartComponent = /** @class */ (function () {
        function High3dPieChartComponent() {
            this.chart = new angularHighcharts.Chart({
                chart: {
                    type: 'pie',
                    options3d: {
                        enabled: true,
                        alpha: 45,
                        beta: 0
                    }
                },
                title: {
                    text: 'Browser market shares at a specific website, 2014'
                },
                tooltip: {
                    pointFormat: '{series.name}: <b>{point.percentage:.1f}%</b>'
                },
                plotOptions: {
                    pie: {
                        allowPointSelect: true,
                        cursor: 'pointer',
                        depth: 35,
                        dataLabels: {
                            enabled: true,
                            format: '{point.name}'
                        }
                    }
                },
                series: [{
                        type: 'pie',
                        name: 'Browser share',
                        data: [
                            ['Firefox', 45.0],
                            ['IE', 26.8],
                            {
                                name: 'Chrome',
                                y: 12.8,
                                sliced: true,
                                selected: true
                            },
                            ['Safari', 8.5],
                            ['Opera', 6.2],
                            ['Others', 0.7]
                        ]
                    }]
            });
        }
        /**
         * @return {?}
         */
        High3dPieChartComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        High3dPieChartComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-high-3d-pie-chart',
                        template: "<div class=\"card\">\n    <div class=\"card-header\">\n      <h5>3D pie</h5>\n    </div>\n    <div class=\"card-body\">\n  \n      <div class=\"row\">\n        <div class=\"col-12\">\n            <div [chart]=\"chart\"></div> \n        </div>\n      </div>\n    </div> \n  </div>  ",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        High3dPieChartComponent.ctorParameters = function () { return []; };
        return High3dPieChartComponent;
    }());
    if (false) {
        /** @type {?} */
        High3dPieChartComponent.prototype.chart;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/libraries/highcharts/high-3d-donut-chart/high-3d-donut-chart.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var High3dDonutChartComponent = /** @class */ (function () {
        function High3dDonutChartComponent() {
            this.chart = new angularHighcharts.Chart({
                chart: {
                    type: 'pie',
                    options3d: {
                        enabled: false,
                    }
                },
                plotOptions: {
                    pie: {
                        innerSize: 100,
                        depth: 45,
                        dataLabels: {
                            enabled: false,
                        }
                    }
                },
                series: (/** @type {?} */ ([{
                        name: 'Delivered amount',
                        data: [
                            ['Bananas', 8],
                            ['Kiwi', 3],
                            ['Mixed nuts', 1],
                            ['Oranges', 6],
                            ['Apples', 8],
                            ['Pears', 4],
                            ['Clementines', 4],
                            ['Reddish (bag)', 1],
                            ['Grapes (bunch)', 1]
                        ]
                    }]))
            });
        }
        /**
         * @return {?}
         */
        High3dDonutChartComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        High3dDonutChartComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-high-3d-donut-chart',
                        template: "<div class=\"row\">\n  <div class=\"col-12\">\n      <div [chart]=\"chart\"></div> \n  </div>\n</div>",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        High3dDonutChartComponent.ctorParameters = function () { return []; };
        return High3dDonutChartComponent;
    }());
    if (false) {
        /** @type {?} */
        High3dDonutChartComponent.prototype.chart;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/libraries/peity/peity.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {string} */
    var PeityType = {
        pie: "pie",
        donut: "donut",
        line: "line",
        bar: "bar",
    };
    /** @type {?} */
    var PeityDonutThemes = {
        primary: ['#967bbd', '#ccbfdf'],
        success: ['#aef5ed', '#4de5d5'],
        warning: ['#f5dfb1', '#ffca5b'],
        info: ['#6ab8f7', '#b2ddff']
    };
    /** @type {?} */
    var PeityBarThemes = {
        primary: ['#967bbd'],
        success: ['#aef5ed'],
        warning: ['#f5dfb1'],
        info: ['#6ab8f7']
    };
    /** @type {?} */
    var DefaultThemes = {
        primary: ['#fff'],
        success: ['#fff'],
        warning: ['#fff'],
        info: ['#fff']
    };
    var PeityComponent = /** @class */ (function () {
        function PeityComponent(el) {
            this.el = el;
            this.values = '';
            this.attributes = {};
        }
        /**
         * @return {?}
         */
        PeityComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        /**
         * @return {?}
         */
        PeityComponent.prototype.ngAfterViewInit = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var fill = this.getColor();
            if (!this.attributes['fill']) {
                switch (this.theme) {
                    case 'primary':
                        this.attributes['fill'] = fill.primary;
                        break;
                    case 'success':
                        this.attributes['fill'] = fill.success;
                        break;
                    case 'warning':
                        this.attributes['fill'] = fill.warning;
                        break;
                    case 'info':
                        this.attributes['fill'] = fill.info;
                        break;
                    default:
                        this.attributes['fill'] = ['#fff'];
                }
            }
            this.peity = $(this.el.nativeElement).peity(this.type, this.attributes);
        };
        /**
         * @return {?}
         */
        PeityComponent.prototype.getColor = /**
         * @return {?}
         */
        function () {
            switch (this.type) {
                case PeityType.donut:
                    return PeityDonutThemes;
                case PeityType.bar:
                    return PeityBarThemes;
                default:
                    return DefaultThemes;
            }
        };
        /**
         * @return {?}
         */
        PeityComponent.prototype.updateSize = /**
         * @return {?}
         */
        function () {
            this.peity = $(this.el.nativeElement).peity(this.type, this.attributes);
        };
        /**
         * @return {?}
         */
        PeityComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        PeityComponent.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
        function (changes) {
            /** @type {?} */
            var values = changes.values;
            if (this.peity && values) {
                this.peity.change();
            }
        };
        PeityComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-peity',
                        template: "<span>{{ values }}</span>\n",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        PeityComponent.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        PeityComponent.propDecorators = {
            type: [{ type: core.Input }],
            values: [{ type: core.Input }],
            attributes: [{ type: core.Input }],
            theme: [{ type: core.Input }]
        };
        return PeityComponent;
    }());
    if (false) {
        /** @type {?} */
        PeityComponent.prototype.type;
        /** @type {?} */
        PeityComponent.prototype.values;
        /** @type {?} */
        PeityComponent.prototype.attributes;
        /** @type {?} */
        PeityComponent.prototype.theme;
        /** @type {?} */
        PeityComponent.prototype.peity;
        /**
         * @type {?}
         * @private
         */
        PeityComponent.prototype.el;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/graphs/circle-progress/circle-progress.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CircleProgressComponent = /** @class */ (function () {
        function CircleProgressComponent() {
        }
        /**
         * @return {?}
         */
        CircleProgressComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        CircleProgressComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-circle-progress',
                        template: "<circle-progress\n  [percent]=\"85\"\n  [radius]=\"100\"\n  [outerStrokeWidth]=\"16\"\n  [innerStrokeWidth]=\"8\"\n  [outerStrokeColor]=\"'#78C000'\"\n  [innerStrokeColor]=\"'#C7E596'\"\n  [animation]=\"true\"\n  [animationDuration]=\"300\"\n></circle-progress>",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        CircleProgressComponent.ctorParameters = function () { return []; };
        return CircleProgressComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/libraries/peity/peity-example/peity-example.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PeityExampleComponent = /** @class */ (function () {
        function PeityExampleComponent() {
            this.values = '5,3,9,6,5,9,7,3,5,2';
        }
        /**
         * @return {?}
         */
        PeityExampleComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            setInterval((/**
             * @return {?}
             */
            function () {
                /** @type {?} */
                var random = Math.round(Math.random() * 10);
                /** @type {?} */
                var values = _this.values.split(',');
                values.shift();
                values.push(String(random));
                _this.values = values.join(',');
            }), 1000);
        };
        /**
         * @return {?}
         */
        PeityExampleComponent.prototype.addNumber = /**
         * @return {?}
         */
        function () {
        };
        PeityExampleComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-peity-example',
                        template: "<div class=\"card\">\n  <div class=\"card-header\">\n    <h5>Peity Chart</h5>\n  </div>\n  <div class=\"card-body\">\n\n    <div class=\"row\">\n      <div class=\"col-12\">\n          <h1>Pie Charts</h1>\n          <xdf-peity [values]=\"'1/5'\" [type]=\"'pie'\"></xdf-peity>   \n          <xdf-peity [values]=\"'226/360'\" [type]=\"'pie'\"></xdf-peity>   \n          <xdf-peity [values]=\"'0.52/1.561'\" [type]=\"'pie'\"></xdf-peity>   \n          <xdf-peity [values]=\"'1,4'\" [type]=\"'pie'\"></xdf-peity>   \n          <xdf-peity [values]=\"'226,134'\" [type]=\"'pie'\"></xdf-peity>   \n          <xdf-peity [values]=\"'0.52,1.041'\" [type]=\"'pie'\"></xdf-peity>   \n          <xdf-peity [values]=\"'1,2,3,2,2'\" [type]=\"'pie'\"></xdf-peity>   \n      </div>\n    </div>\n\n    <div class=\"row\">\n      <div class=\"col-12\">\n          <h1>Donut Charts</h1>\n          <xdf-peity [values]=\"'1/5'\" [type]=\"'donut'\"></xdf-peity>   \n          <xdf-peity [values]=\"'226/360'\" [type]=\"'donut'\"></xdf-peity>   \n          <xdf-peity [values]=\"'0.52/1.561'\" [type]=\"'donut'\"></xdf-peity>   \n          <xdf-peity [values]=\"'1,4'\" [type]=\"'donut'\"></xdf-peity>   \n          <xdf-peity [values]=\"'226,134'\" [type]=\"'donut'\"></xdf-peity>   \n          <xdf-peity [values]=\"'0.52,1.041'\" [type]=\"'donut'\"></xdf-peity>   \n          <xdf-peity [values]=\"'1,2,3,2,2'\" [type]=\"'donut'\"></xdf-peity>   \n      </div>\n    </div>\n\n    <div class=\"row\">\n      <div class=\"col-12\">\n          <h1>Line Charts</h1>\n          <xdf-peity [values]=\"'5,3,9,6,5,9,7,3,5,2'\" [type]=\"'line'\"></xdf-peity>   \n          <xdf-peity [values]=\"'5,3,2,-1,-3,-2,2,3,5,2'\" [type]=\"'line'\"></xdf-peity>   \n          <xdf-peity [values]=\"'0,-3,-6,-4,-5,-4,-7,-3,-5,-2'\" [type]=\"'line'\"></xdf-peity>   \n      </div>\n    </div>\n\n    <div class=\"row\">\n      <div class=\"col-12\">\n          <h1>Bar Charts</h1>\n          <xdf-peity values=\"5,3,9,6,5,9,7,3,5,2\" type=\"bar\"></xdf-peity>   \n          <xdf-peity [values]=\"'5,3,2,-1,-3,-2,2,3,5,2'\" [type]=\"'bar'\"></xdf-peity>   \n          <xdf-peity [values]=\"'0,-3,-6,-4,-5,-4,-7,-3,-5,-2'\" [type]=\"'bar'\"></xdf-peity>   \n      </div>\n    </div>\n\n    <div class=\"row\">\n      <div class=\"col-12\">\n          <h1>Updating Chart</h1>\n          <xdf-peity [values]=\"values\" [type]=\"'line'\"></xdf-peity>   \n      </div>\n    </div>\n    \n  </div> \n</div>\n",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        PeityExampleComponent.ctorParameters = function () { return []; };
        return PeityExampleComponent;
    }());
    if (false) {
        /** @type {?} */
        PeityExampleComponent.prototype.values;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/libraries/highcharts/high-area-chart/high-area-chart.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var HighAreaChartComponent = /** @class */ (function () {
        function HighAreaChartComponent() {
            this.chart = new angularHighcharts.Chart({
                chart: {
                    type: 'area',
                    backgroundColor: 'transparent',
                    height: 234
                },
                // tooltip: {
                //   backgroundColor: '#FCFFC5',
                //   borderColor: 'black',
                //   borderRadius: 10,
                //   borderWidth: 3
                // },
                title: {
                    text: 'Linechart',
                    style: {
                        display: 'none'
                    }
                },
                credits: {
                    enabled: false
                },
                yAxis: {
                    gridLineWidth: 0,
                    visible: false
                },
                xAxis: {
                    visible: false
                },
                plotOptions: {
                    series: {
                        marker: {
                            enabled: false
                        }
                    }
                },
                series: (/** @type {?} */ ([{
                        name: 'Line 1',
                        showInLegend: true,
                        data: [{
                                y: 20,
                                name: 'Line 1'
                            }, 73, 53, 47, 8, 15, 21, 1, 33, 27],
                        color: {
                            linearGradient: { x1: 0, x2: 0, y1: 0, y2: 1 },
                            stops: [
                                [0, '#6ab8f7'],
                                [1, highcharts.color('#6ab8f7').setOpacity(0).get('rgba')]
                            ]
                        }
                    },
                    {
                        name: 'Line 2',
                        showInLegend: true,
                        data: [22, 15, 33, 99, 11, 44, 8, 16, 42, 65],
                        color: {
                            linearGradient: { x1: 0, x2: 0, y1: 0, y2: 1 },
                            stops: [
                                [0, '#1bc9b7'],
                                [1, highcharts.color('#1bc9b7').setOpacity(0).get('rgba')] // end
                            ]
                        }
                    }
                ]))
            });
        }
        /**
         * @return {?}
         */
        HighAreaChartComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        HighAreaChartComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-high-area-chart',
                        template: "<div [chart]=\"chart\"></div>",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        HighAreaChartComponent.ctorParameters = function () { return []; };
        return HighAreaChartComponent;
    }());
    if (false) {
        /** @type {?} */
        HighAreaChartComponent.prototype.chart;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/templates/widget-panel/widget-panel.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var WidgetPanelComponent = /** @class */ (function () {
        function WidgetPanelComponent() {
            this.options = {
                elevation: false,
                title: {
                    primary: 'Primary',
                    secondary: 'Secondary'
                }
            };
            this.refreshed = new core.EventEmitter();
        }
        /**
         * @return {?}
         */
        WidgetPanelComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        /**
         * @return {?}
         */
        WidgetPanelComponent.prototype.refresh = /**
         * @return {?}
         */
        function () {
            this.refreshed.emit();
        };
        WidgetPanelComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-widget-panel',
                        template: "<div [ngClass]=\"{'mat-elevation-z8': options.elevation }\" style=\"border-radius: 4px;\"> \n    <div class=\"panel mat-elevation-z8\">\n        <div class=\"panel-hdr\" role=\"heading\">\n            <h2>\n                {{ options.title.primary | translate }} <span class=\"fw-300\">{{ options.title.secondary | translate }}</span>\n            </h2>\n            <div class=\"panel-toolbar\" role=\"menu\">\n                <button class=\"btn btn-toolbar-master waves-effect waves-themed pr-4 pl-4\" (click)=\"refresh()\"><i class=\"fa fa-refresh\"></i></button>\n            </div>\n        </div>\n        <div class=\"panel-container show\" role=\"content\"><div class=\"loader\"><i class=\"fal fa-spinner-third fa-spin-4x fs-xxl\"></i></div>\n            <div class=\"panel-content position-relative\">\n                <ng-content></ng-content>\n            </div>\n        </div>\n    </div>\n</div>",
                        styles: [".panel{background-color:#f3f3f4;border-radius:4px;display:flex;flex-direction:column;position:relative;box-shadow:0 0 13px 0 rgba(62,44,90,.08);margin-bottom:1.5rem;border:1px solid rgba(0,0,0,.09);border-bottom:1px solid #e0e0e0;transition:border .5s ease-out}.panel .panel-container .panel-content:last-child,.panel .panel-container .panel-content:only-child{border-radius:0 0 4px 4px}.panel-hdr{display:flex;align-items:center;background:#fff;min-height:3rem;border-bottom:1px solid rgba(0,0,0,.07);border-radius:4px 4px 0 0;transition:background-color .4s ease-out}.panel-hdr h2>[class*=fw-]{margin-left:4px}.panel-hdr h2:not(:only-child){margin-right:.66667rem}.panel-hdr>:first-child{padding-left:1rem}.panel-hdr h2{flex:1;font-size:.875rem;margin:0;display:flex;align-items:center;line-height:3rem;color:#333;position:relative;font-weight:500}.panel-toolbar .btn-toolbar-master{height:3rem;width:1.826875rem;border-radius:0 3px 0 0;margin-right:-1rem;margin-left:.5rem;padding:0 13px;background:0 0;border:0;font-size:1rem;color:inherit;display:flex;align-items:center;justify-content:center}.waves-effect{position:relative;cursor:pointer;display:inline-block;overflow:hidden;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;-webkit-tap-highlight-color:transparent}.panel-hdr>:last-child{padding-right:1rem}.panel-toolbar{display:flex;align-items:center}"]
                    }] }
        ];
        /** @nocollapse */
        WidgetPanelComponent.ctorParameters = function () { return []; };
        WidgetPanelComponent.propDecorators = {
            options: [{ type: core.Input }],
            refreshed: [{ type: core.Output }]
        };
        return WidgetPanelComponent;
    }());
    if (false) {
        /** @type {?} */
        WidgetPanelComponent.prototype.options;
        /** @type {?} */
        WidgetPanelComponent.prototype.refreshed;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/charts/column-line-pie-chart/column-line-pie-chart.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ColumnLinePieChartComponent = /** @class */ (function () {
        function ColumnLinePieChartComponent() {
        }
        /**
         * @return {?}
         */
        ColumnLinePieChartComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        ColumnLinePieChartComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-column-line-pie-chart',
                        template: "<xdf-widget-panel [options]=\"panelOptions\">\n    <xdf-high-column-line-pie-chart></xdf-high-column-line-pie-chart>\n</xdf-widget-panel>",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        ColumnLinePieChartComponent.ctorParameters = function () { return []; };
        ColumnLinePieChartComponent.propDecorators = {
            panelOptions: [{ type: core.Input }]
        };
        return ColumnLinePieChartComponent;
    }());
    if (false) {
        /** @type {?} */
        ColumnLinePieChartComponent.prototype.panelOptions;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/charts/area-peity-bar-chart/area-peity-bar-chart.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AreaPeityBarChartComponent = /** @class */ (function () {
        function AreaPeityBarChartComponent() {
        }
        /**
         * @return {?}
         */
        AreaPeityBarChartComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        AreaPeityBarChartComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-area-peity-bar-chart',
                        template: "<xdf-widget-panel [options]=\"panelOptions\">\n    <div class=\"pb-4 pt-2\">\n        <div class=\"row\">\n            <div class=\"col-6 col-xl-3 d-sm-flex align-items-center\">\n                <div class=\"p-2 mr-3 bg-info-200 rounded\">\n                    <xdf-peity [values]=\"'5,3,1,7,9'\" [type]=\"'bar'\" theme=\"none\" [attributes]='{ \"width\": 27, \"height\": 27 }'></xdf-peity>   \n                </div>\n                <div>\n                    <label class=\"fs-sm mb-0\">Bounce Rate</label>\n                    <h4 class=\"font-weight-bold mb-0\">37.56%</h4>\n                </div>\n            </div>\n            <div class=\"col-6 col-xl-3 d-sm-flex align-items-center\">\n                <div class=\"p-2 mr-3 bg-info-300 rounded\">\n                    <xdf-peity [values]=\"'5,8,2,7,9'\" [type]=\"'bar'\" theme=\"none\" [attributes]='{ \"width\": 27, \"height\": 27 }'></xdf-peity>   \n                </div>\n                <div>\n                    <label class=\"fs-sm mb-0\">Sessions</label>\n                    <h4 class=\"font-weight-bold mb-0\">75</h4>\n                </div>\n            </div>\n            <div class=\"col-6 col-xl-3 d-sm-flex align-items-center\">\n                <div class=\"p-2 mr-3 bg-success-300 rounded\">\n                    <xdf-peity [values]=\"'5,2,2,7,9'\" [type]=\"'bar'\" theme=\"none\" [attributes]='{ \"width\": 27, \"height\": 27 }'></xdf-peity>   \n                </div>\n                <div>\n                    <label class=\"fs-sm mb-0\">New Sessions</label>\n                    <h4 class=\"font-weight-bold mb-0\">12.17%</h4>\n                </div>\n            </div>\n            <div class=\"col-6 col-xl-3 d-sm-flex align-items-center\">\n                <div class=\"p-2 mr-3 bg-success-500 rounded\">\n                    <xdf-peity [values]=\"'1,3,2,7,9'\" [type]=\"'bar'\" theme=\"none\" [attributes]='{ \"width\": 27, \"height\": 27 }'></xdf-peity>   \n                </div>\n                <div>\n                    <label class=\"fs-sm mb-0\">Clickthrough</label>\n                    <h4 class=\"font-weight-bold mb-0\">19.77%</h4>\n                </div>\n            </div>\n        </div>\n    </div>\n    <xdf-high-area-chart></xdf-high-area-chart>\n</xdf-widget-panel>",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        AreaPeityBarChartComponent.ctorParameters = function () { return []; };
        AreaPeityBarChartComponent.propDecorators = {
            panelOptions: [{ type: core.Input }]
        };
        return AreaPeityBarChartComponent;
    }());
    if (false) {
        /** @type {?} */
        AreaPeityBarChartComponent.prototype.panelOptions;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/widgets/summary-donut-widget/summary-donut-widget.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SummaryDonutWidgetComponent = /** @class */ (function () {
        function SummaryDonutWidgetComponent() {
        }
        /**
         * @return {?}
         */
        SummaryDonutWidgetComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        SummaryDonutWidgetComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-summary-donut-widget',
                        template: "<div class=\"d-flex\">\n    <div class=\"mr-2\">\n        <xdf-peity [values]=\"values\" [type]=\"'donut'\" [theme]=\"theme\" [attributes]='{ \"innerRadius\": 14, \"radius\": 20 }'></xdf-peity>   \n    </div>\n    <div>\n        <label class=\"fs-sm mb-0 mt-2 mt-md-0\">{{header}}</label>\n        <h4 class=\"font-weight-bold mb-0\">{{textValue}}</h4>\n    </div>\n</div>",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        SummaryDonutWidgetComponent.ctorParameters = function () { return []; };
        SummaryDonutWidgetComponent.propDecorators = {
            textValue: [{ type: core.Input }],
            header: [{ type: core.Input }],
            theme: [{ type: core.Input }],
            values: [{ type: core.Input }]
        };
        return SummaryDonutWidgetComponent;
    }());
    if (false) {
        /** @type {?} */
        SummaryDonutWidgetComponent.prototype.textValue;
        /** @type {?} */
        SummaryDonutWidgetComponent.prototype.header;
        /** @type {?} */
        SummaryDonutWidgetComponent.prototype.theme;
        /** @type {?} */
        SummaryDonutWidgetComponent.prototype.values;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/widgets/summary-box-widget/summary-box-widget.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {string} */
    var SummaryWidgetType = {
        info: "info",
        warning: "warning",
        primary: "primary",
        currency: "success",
        danger: "danger",
    };
    var SummaryBoxWidgetComponent = /** @class */ (function () {
        function SummaryBoxWidgetComponent() {
        }
        /**
         * @return {?}
         */
        SummaryBoxWidgetComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        SummaryBoxWidgetComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-summary-box-widget',
                        template: "<div class=\"p-3 rounded overflow-hidden position-relative text-white mb-3\"\n    [ngClass]=\"{'bg-primary-300': type === 'primary','bg-warning-400': type === 'warning',\n    'bg-success-600': type === 'success','bg-info-200': type === 'info','bg-danger-400': type === 'danger'}\">\n\n    <div class=\"\">\n        <h3 class=\"display-4 d-block l-h-n m-0 fw-500\">\n            {{textValue}}\n            <small class=\"m-0 l-h-n\">{{ legend | translate }}</small>\n        </h3>\n    </div>\n\n    <i *ngIf=\"type === 'primary'\" class=\"position-absolute pos-right pos-bottom opacity-15 mb-n2 mr-n1\" \n        [ngClass]=\"icon\"\n        style=\"font-size:6rem\"></i>\n    <i *ngIf=\"type === 'warning'\" class=\"position-absolute pos-right pos-bottom opacity-15 mb-n2 mr-n4\" \n        [ngClass]=\"icon\"\n        style=\"font-size:6rem\"></i>\n    <i *ngIf=\"type === 'success'\" class=\"position-absolute pos-right pos-bottom opacity-15 mr-2\" \n        [ngClass]=\"icon\"\n        style=\"font-size:6rem\"></i>\n    <i *ngIf=\"type === 'info'\" class=\"position-absolute pos-right pos-bottom opacity-15 mb-n3 mr-n3\" \n        [ngClass]=\"icon\"\n        style=\"font-size:6rem\"></i>\n    <i *ngIf=\"type === 'danger'\" class=\"position-absolute pos-right pos-bottom opacity-15 mb-n3 mr-n3\" \n        [ngClass]=\"icon\"\n        style=\"font-size:6rem\"></i>\n</div>\n",
                        styles: [".text-white{color:#fff!important}.position-relative{position:relative!important}.overflow-hidden{overflow:hidden!important}.rounded{border-radius:4px!important}.fw-500{font-weight:500!important}.d-block{display:block!important}.display-4{font-size:2.5rem;font-weight:300;line-height:1.57}.opacity-15{opacity:.15}.pos-bottom{bottom:0}.pos-right{right:0}.l-h-n{line-height:normal}.h1 small,.h2 small,.h3 small,.h4 small,.h5 small,.h6 small,h1 small,h2 small,h3 small,h4 small,h5 small,h6 small{font-weight:300;display:block;font-size:.9375rem;line-height:1.5;margin:2px 0 1.5rem}"]
                    }] }
        ];
        /** @nocollapse */
        SummaryBoxWidgetComponent.ctorParameters = function () { return []; };
        SummaryBoxWidgetComponent.propDecorators = {
            type: [{ type: core.Input }],
            textValue: [{ type: core.Input }],
            legend: [{ type: core.Input }],
            icon: [{ type: core.Input }]
        };
        return SummaryBoxWidgetComponent;
    }());
    if (false) {
        /** @type {?} */
        SummaryBoxWidgetComponent.prototype.type;
        /** @type {?} */
        SummaryBoxWidgetComponent.prototype.textValue;
        /** @type {?} */
        SummaryBoxWidgetComponent.prototype.legend;
        /** @type {?} */
        SummaryBoxWidgetComponent.prototype.icon;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/templates/card-widget-panel/card-widget-panel.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CardWidgetPanelComponent = /** @class */ (function () {
        function CardWidgetPanelComponent() {
            this.options = {
                elevation: false,
                title: {
                    primary: 'Primary',
                    secondary: 'Secondary'
                }
            };
            this.refreshed = new core.EventEmitter();
        }
        /**
         * @return {?}
         */
        CardWidgetPanelComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        /**
         * @return {?}
         */
        CardWidgetPanelComponent.prototype.refresh = /**
         * @return {?}
         */
        function () {
            this.refreshed.emit();
        };
        CardWidgetPanelComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-card-widget-panel',
                        template: "<div class=\"card\">\n    <div class=\"card-header\">\n        <h2>\n            {{ options.title.primary | translate }}&nbsp;<span class=\"fw-300\">{{ options.title.secondary | translate }}</span>\n        </h2>\n        <div class=\"panel-toolbar\" role=\"menu\">\n            <button class=\"btn btn-toolbar-master waves-effect waves-themed pr-4 pl-4\" (click)=\"refresh()\"><i class=\"fa fa-refresh\"></i></button>\n        </div>\n    </div>\n    <div class=\"card-body\">\n        <ng-content></ng-content>\n    </div>\n</div>",
                        styles: [".panel-toolbar{display:flex;align-items:center}.card-header{display:flex;padding:0 1rem 0 1.25rem!important}.card-header h2{flex:1;font-size:.875rem;margin:0;display:flex;align-items:center;line-height:3rem;color:#333;position:relative;font-weight:500}.panel-toolbar .btn-toolbar-master{height:3rem;width:1.826875rem;border-radius:0 3px 0 0;margin-right:-1rem;margin-left:.5rem;padding:0 13px;background:0 0;border:0;font-size:1rem;color:inherit;display:flex;align-items:center;justify-content:center}"]
                    }] }
        ];
        /** @nocollapse */
        CardWidgetPanelComponent.ctorParameters = function () { return []; };
        CardWidgetPanelComponent.propDecorators = {
            options: [{ type: core.Input }],
            refreshed: [{ type: core.Output }]
        };
        return CardWidgetPanelComponent;
    }());
    if (false) {
        /** @type {?} */
        CardWidgetPanelComponent.prototype.options;
        /** @type {?} */
        CardWidgetPanelComponent.prototype.refreshed;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/widgets/summary-box-amount-widget/summary-box-amount-widget.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SummaryBoxAmountWidgetComponent = /** @class */ (function () {
        function SummaryBoxAmountWidgetComponent() {
            this.theme = "primary";
        }
        /**
         * @return {?}
         */
        SummaryBoxAmountWidgetComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        SummaryBoxAmountWidgetComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-summary-box-amount-widget',
                        template: "<div class=\"d-lg-flex align-items-center\">\n    <div class=\"d-inline-flex flex-column justify-content-center mr-3\">\n        <span class=\"fw-300 fs-xs d-block opacity-50\">\n            <small >{{header}}</small>\n        </span>\n        <span class=\"fw-500 fs-xl d-block {{theme}}\">\n            {{textValue}}\n        </span>\n    </div>\n    <div class=\"mr-2\">\n        <xdf-peity [values]=\"values\" [type]=\"'bar'\" [theme]=\"theme\" [attributes]='{ \"width\": 60, \"height\": 40 }'></xdf-peity>   \n    </div>\n</div>",
                        styles: [".fs-xs{font-size:.75rem}.fs-xl{font-size:1rem}.primary{color:#967bbd}.success{color:#aef5ed}.warning{color:#f5dfb1}.info{color:#6ab8f7}"]
                    }] }
        ];
        /** @nocollapse */
        SummaryBoxAmountWidgetComponent.ctorParameters = function () { return []; };
        SummaryBoxAmountWidgetComponent.propDecorators = {
            textValue: [{ type: core.Input }],
            header: [{ type: core.Input }],
            theme: [{ type: core.Input }],
            values: [{ type: core.Input }]
        };
        return SummaryBoxAmountWidgetComponent;
    }());
    if (false) {
        /** @type {?} */
        SummaryBoxAmountWidgetComponent.prototype.textValue;
        /** @type {?} */
        SummaryBoxAmountWidgetComponent.prototype.header;
        /** @type {?} */
        SummaryBoxAmountWidgetComponent.prototype.theme;
        /** @type {?} */
        SummaryBoxAmountWidgetComponent.prototype.values;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/widgets/stats-widget/stats-widget.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var StatsWidgetComponent = /** @class */ (function () {
        function StatsWidgetComponent() {
            this.icon = "fa fa-desktop";
            this.color = "bg-blue";
        }
        /**
         * @return {?}
         */
        StatsWidgetComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        StatsWidgetComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'xdf-stats-widget',
                        template: "<div class=\"widget widget-stats\" [ngClass]=\"color\">\n    <div class=\"stats-icon\"><i [ngClass]=\"icon\"></i></div>\n    <div class=\"stats-info\">\n        <h4>{{header}}</h4>\n        <p>{{textValue}}</p>\t\n    </div>\n    <div class=\"stats-link\">\n        <a href=\"javascript:;\"><span>View Detail</span>&nbsp;<i class=\"fa fa-arrow-circle-right\"></i></a>\n    </div>\n</div>",
                        styles: [".widget-stats,.widget.widget-stats{position:relative;color:#fff;padding:15px;border-radius:4px}.widget{overflow:hidden;margin-bottom:20px;background:#fff;color:inherit;padding:0;border-radius:0}.widget-stats .stats-icon,.widget.widget-stats .stats-icon{font-size:42px;height:56px;width:56px;text-align:center;line-height:56px;color:rgba(0,0,0,.15);position:absolute;right:15px;top:15px;margin-left:15px}.widget-stats .stats-link a,.widget.widget-stats .stats-link a{display:block;margin:15px -15px -15px;padding:7px 15px;background:rgba(0,0,0,.4);text-align:right;color:rgba(255,255,255,.7);text-decoration:none}.widget-stats .stats-link a:focus,.widget-stats .stats-link a:hover,.widget.widget-stats .stats-link a:focus,.widget.widget-stats .stats-link a:hover{background:rgba(0,0,0,.6);color:#fff}.widget-stats .stats-info h4,.widget.widget-stats .stats-info h4{font-weight:600;font-size:12px;margin:5px 0;color:rgba(255,255,255,.7)}.widget-stats .stats-info p,.widget.widget-stats .stats-info p{font-size:24px;font-weight:600;margin-bottom:0}.stats-link i{font-weight:900;font-size:.75rem}.bg-blue{background-color:#348fe2!important}.bg-red{background-color:#ff5b57!important}.bg-orange{background-color:#f59c1a!important}.bg-info{background-color:#49b6d6!important}"]
                    }] }
        ];
        /** @nocollapse */
        StatsWidgetComponent.ctorParameters = function () { return []; };
        StatsWidgetComponent.propDecorators = {
            icon: [{ type: core.Input }],
            color: [{ type: core.Input }],
            header: [{ type: core.Input }],
            textValue: [{ type: core.Input }]
        };
        return StatsWidgetComponent;
    }());
    if (false) {
        /** @type {?} */
        StatsWidgetComponent.prototype.icon;
        /** @type {?} */
        StatsWidgetComponent.prototype.color;
        /** @type {?} */
        StatsWidgetComponent.prototype.header;
        /** @type {?} */
        StatsWidgetComponent.prototype.textValue;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/xdf-graph.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var XdfGraphModule = /** @class */ (function () {
        function XdfGraphModule() {
        }
        XdfGraphModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            common.CommonModule,
                            core$1.TranslateModule,
                            ng2Charts.ChartsModule,
                            ngxCharts.NgxChartsModule,
                            angularHighcharts.ChartModule,
                            ngCircleProgress.NgCircleProgressModule.forRoot()
                        ],
                        declarations: [
                            Ng2ChartsComponent,
                            PieChartComponent, BarChartComponent,
                            DoughnutChartComponent, PolarAreaChartComponent, RadarChartComponent,
                            HighchartsComponent, HighLineChartComponent,
                            HighPieChartComponent, HighDonutChartComponent, HighColumnLinePieChartComponent,
                            HighDualAxesLineColumnChartComponent, HighSplineUpdatingChartComponent,
                            High3dColumnChartComponent, High3dColumnGroupChartComponent, High3dPieChartComponent,
                            High3dDonutChartComponent,
                            HighAreaChartComponent,
                            PeityComponent,
                            PeityExampleComponent,
                            CircleProgressComponent,
                            SummaryDonutWidgetComponent, SummaryBoxWidgetComponent,
                            ColumnLinePieChartComponent,
                            AreaPeityBarChartComponent,
                            HighchartsComponent,
                            Ng2ChartsComponent,
                            WidgetPanelComponent,
                            ColumnLinePieChartComponent,
                            CardWidgetPanelComponent,
                            SummaryBoxAmountWidgetComponent,
                            StatsWidgetComponent
                        ],
                        providers: [],
                        exports: [
                            PieChartComponent, BarChartComponent,
                            DoughnutChartComponent, PolarAreaChartComponent, RadarChartComponent,
                            HighchartsComponent, HighLineChartComponent,
                            HighPieChartComponent, HighDonutChartComponent, HighColumnLinePieChartComponent,
                            HighDualAxesLineColumnChartComponent, HighSplineUpdatingChartComponent,
                            High3dColumnChartComponent, High3dColumnGroupChartComponent, High3dPieChartComponent,
                            High3dDonutChartComponent, HighAreaChartComponent,
                            PeityComponent,
                            PeityExampleComponent,
                            CircleProgressComponent,
                            SummaryDonutWidgetComponent, SummaryBoxWidgetComponent,
                            SummaryBoxAmountWidgetComponent,
                            StatsWidgetComponent,
                            ColumnLinePieChartComponent,
                            AreaPeityBarChartComponent,
                            WidgetPanelComponent,
                            HighchartsComponent,
                            Ng2ChartsComponent
                        ]
                    },] }
        ];
        return XdfGraphModule;
    }());

    exports.AreaPeityBarChartComponent = AreaPeityBarChartComponent;
    exports.BarChartComponent = BarChartComponent;
    exports.CircleProgressComponent = CircleProgressComponent;
    exports.ColumnLinePieChartComponent = ColumnLinePieChartComponent;
    exports.DefaultThemes = DefaultThemes;
    exports.DoughnutChartComponent = DoughnutChartComponent;
    exports.High3dColumnChartComponent = High3dColumnChartComponent;
    exports.High3dColumnGroupChartComponent = High3dColumnGroupChartComponent;
    exports.High3dDonutChartComponent = High3dDonutChartComponent;
    exports.High3dPieChartComponent = High3dPieChartComponent;
    exports.HighAreaChartComponent = HighAreaChartComponent;
    exports.HighColumnLinePieChartComponent = HighColumnLinePieChartComponent;
    exports.HighDonutChartComponent = HighDonutChartComponent;
    exports.HighDualAxesLineColumnChartComponent = HighDualAxesLineColumnChartComponent;
    exports.HighLineChartComponent = HighLineChartComponent;
    exports.HighPieChartComponent = HighPieChartComponent;
    exports.HighSplineUpdatingChartComponent = HighSplineUpdatingChartComponent;
    exports.HighchartsComponent = HighchartsComponent;
    exports.Ng2ChartsComponent = Ng2ChartsComponent;
    exports.PeityBarThemes = PeityBarThemes;
    exports.PeityComponent = PeityComponent;
    exports.PeityDonutThemes = PeityDonutThemes;
    exports.PieChartComponent = PieChartComponent;
    exports.PolarAreaChartComponent = PolarAreaChartComponent;
    exports.RadarChartComponent = RadarChartComponent;
    exports.StatsWidgetComponent = StatsWidgetComponent;
    exports.SummaryBoxAmountWidgetComponent = SummaryBoxAmountWidgetComponent;
    exports.SummaryBoxWidgetComponent = SummaryBoxWidgetComponent;
    exports.SummaryDonutWidgetComponent = SummaryDonutWidgetComponent;
    exports.SummaryWidgetType = SummaryWidgetType;
    exports.WidgetPanelComponent = WidgetPanelComponent;
    exports.XdfGraphModule = XdfGraphModule;
    exports.ɵa = PeityExampleComponent;
    exports.ɵb = CardWidgetPanelComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=xdf-graph.umd.js.map
