(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('@angular/router'), require('rxjs/operators'), require('@xdf/commons'), require('@angular/common'), require('@ngx-translate/core'), require('rxjs'), require('@angular/common/http')) :
    typeof define === 'function' && define.amd ? define('@xdf/security', ['exports', '@angular/core', '@angular/forms', '@angular/router', 'rxjs/operators', '@xdf/commons', '@angular/common', '@ngx-translate/core', 'rxjs', '@angular/common/http'], factory) :
    (global = global || self, factory((global.xdf = global.xdf || {}, global.xdf.security = {}), global.ng.core, global.ng.forms, global.ng.router, global.rxjs.operators, global['xdf-commons'], global.ng.common, global['ngx-translate'].core, global.rxjs, global.ng.common.http));
}(this, (function (exports, core, forms, router, operators, commons, common, core$1, rxjs, http) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    var LoginComponent = /** @class */ (function () {
        function LoginComponent(formBuilder, route, router, authenticationService) {
            this.formBuilder = formBuilder;
            this.route = route;
            this.router = router;
            this.authenticationService = authenticationService;
            this.loading = false;
            this.submitted = false;
            this.error = '';
            // redirect to home if already logged
            if (this.authenticationService.currentUserValue) {
                this.router.navigate(['/home']);
            }
        }
        LoginComponent.prototype.ngOnInit = function () {
            this.loginForm = this.formBuilder.group({
                username: ['', forms.Validators.required],
                password: ['', forms.Validators.required]
            });
            // get return url from route parameters or default to '/'
            var attReturnUrl = 'returnUrl';
            this.returnUrl = this.route.snapshot.queryParams[attReturnUrl] || '/';
        };
        Object.defineProperty(LoginComponent.prototype, "f", {
            get: function () { return this.loginForm.controls; },
            enumerable: true,
            configurable: true
        });
        LoginComponent.prototype.onSubmit = function () {
            var _this = this;
            this.submitted = true;
            // stop here if form is invalid
            if (this.loginForm.invalid) {
                return;
            }
            this.loading = true;
            this.authenticationService.login(this.f.username.value, this.f.password.value)
                .pipe(operators.first())
                .subscribe(function (data) {
                var returnUrl = JSON.parse(localStorage.getItem('returnUrl'));
                if (returnUrl) {
                    _this.returnUrl = returnUrl;
                    localStorage.removeItem('returnUrl');
                }
                _this.router.navigate([_this.returnUrl]);
            }, function (error) {
                _this.error = error;
                _this.loading = false;
            });
        };
        LoginComponent.ctorParameters = function () { return [
            { type: forms.FormBuilder },
            { type: router.ActivatedRoute },
            { type: router.Router },
            { type: commons.AuthenticationService }
        ]; };
        LoginComponent = __decorate([
            core.Component({
                selector: 'xdf-example-login',
                template: "<div class=\"col-md-6 offset-md-3 mt-5\">\n    <div class=\"alert alert-info\">\n        Username: test<br />\n        Password: test\n    </div>\n    <div class=\"card\">\n        <h4 class=\"card-header\">{{ 'login.title' | translate }}</h4>\n        <div class=\"card-body\">\n            <form [formGroup]=\"loginForm\" (ngSubmit)=\"onSubmit()\">\n                <div class=\"form-group\">\n                    <label for=\"username\">{{ 'label.username' | translate }}</label>\n                    <input type=\"text\" formControlName=\"username\" class=\"form-control\" [ngClass]=\"{ 'is-invalid': submitted && f.username.errors }\" />\n                    <div *ngIf=\"submitted && f.username.errors\" class=\"invalid-feedback\">\n                        <div *ngIf=\"f.username.errors.required\">Username is required</div>\n                    </div>\n                </div>\n                <div class=\"form-group\">\n                    <label for=\"password\">{{ 'label.password' | translate }}</label>\n                    <input type=\"password\" formControlName=\"password\" class=\"form-control\" [ngClass]=\"{ 'is-invalid': submitted && f.password.errors }\" />\n                    <div *ngIf=\"submitted && f.password.errors\" class=\"invalid-feedback\">\n                        <div *ngIf=\"f.password.errors.required\">Password is required</div>\n                    </div>\n                </div>\n                <button [disabled]=\"loading\" class=\"btn btn-primary\">\n                    <span *ngIf=\"loading\" class=\"spinner-border spinner-border-sm mr-1\"></span>\n                    Login\n                </button>\n                <div *ngIf=\"error\" class=\"alert alert-danger mt-3 mb-0\">{{ error }}</div>\n            </form>\n        </div>\n    </div>\n  </div>\n  ",
                styles: [""]
            }),
            __metadata("design:paramtypes", [forms.FormBuilder,
                router.ActivatedRoute,
                router.Router,
                commons.AuthenticationService])
        ], LoginComponent);
        return LoginComponent;
    }());

    var AuthorizationResource = /** @class */ (function () {
        function AuthorizationResource(program, control) {
            this.program = program;
            this.control = control;
        }
        return AuthorizationResource;
    }());
    var AuthorizationService = /** @class */ (function () {
        function AuthorizationService(http) {
            this.http = http;
        }
        AuthorizationService.prototype.authorize = function (programId) {
            return this.http.get("./service/security/controls/" + programId);
        };
        AuthorizationService.ctorParameters = function () { return [
            { type: http.HttpClient }
        ]; };
        AuthorizationService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function AuthorizationService_Factory() { return new AuthorizationService(core.ɵɵinject(http.HttpClient)); }, token: AuthorizationService, providedIn: "root" });
        AuthorizationService = __decorate([
            core.Injectable({
                providedIn: 'root'
            }),
            __metadata("design:paramtypes", [http.HttpClient])
        ], AuthorizationService);
        return AuthorizationService;
    }());

    var AuthorizationResolver = /** @class */ (function () {
        function AuthorizationResolver(authorizationService, notificationService) {
            this.authorizationService = authorizationService;
            this.notificationService = notificationService;
        }
        AuthorizationResolver.prototype.resolve = function (route) {
            var key = 'program';
            var program = route.data[key];
            if (!program) {
                this.notificationService.showMessage("Route requires 'program' parameter", 'Security Error!', commons.NotificationType.error);
                return rxjs.throwError("Not Found 'program' Parameter");
            }
            return this.authorizationService.authorize(program);
        };
        AuthorizationResolver.ctorParameters = function () { return [
            { type: AuthorizationService },
            { type: commons.NotificationService }
        ]; };
        AuthorizationResolver = __decorate([
            core.Injectable(),
            __metadata("design:paramtypes", [AuthorizationService,
                commons.NotificationService])
        ], AuthorizationResolver);
        return AuthorizationResolver;
    }());

    var XdfSecurityModule = /** @class */ (function () {
        function XdfSecurityModule() {
        }
        XdfSecurityModule = __decorate([
            core.NgModule({
                declarations: [
                    LoginComponent
                ],
                imports: [
                    forms.FormsModule,
                    common.CommonModule,
                    router.RouterModule,
                    forms.ReactiveFormsModule,
                    core$1.TranslateModule
                ],
                exports: [
                    LoginComponent
                ],
                providers: [
                    AuthorizationResolver
                ]
            })
        ], XdfSecurityModule);
        return XdfSecurityModule;
    }());

    /**
     * @description
     * Permite validar que antes de usar el mantenimiento el usuario esté logueado en la aplicación.
     * La presente implementación supone que el login es parte de los routes configurados.
     */
    var AuthGuard = /** @class */ (function () {
        function AuthGuard(router, authenticationService) {
            this.router = router;
            this.authenticationService = authenticationService;
        }
        AuthGuard.prototype.canLoad = function () {
            var currentUser = this.authenticationService.currentUserValue;
            var response = !(!currentUser);
            return rxjs.of(response);
        };
        AuthGuard.prototype.canActivate = function (route, state) {
            var currentUser = this.authenticationService.currentUserValue;
            if (currentUser) {
                // logged in so return true
                return true;
            }
            // not logged in so redirect to login page with the return url
            if (state.url) {
                localStorage.setItem('returnUrl', JSON.stringify(state.url));
            }
            this.router.navigate(['login']);
            return false;
        };
        AuthGuard.ctorParameters = function () { return [
            { type: router.Router },
            { type: commons.AuthenticationService }
        ]; };
        AuthGuard.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function AuthGuard_Factory() { return new AuthGuard(core.ɵɵinject(router.Router), core.ɵɵinject(commons.AuthenticationService)); }, token: AuthGuard, providedIn: "root" });
        AuthGuard = __decorate([
            core.Injectable({
                providedIn: 'root'
            }),
            __metadata("design:paramtypes", [router.Router,
                commons.AuthenticationService])
        ], AuthGuard);
        return AuthGuard;
    }());

    var OAuthGuard = /** @class */ (function () {
        function OAuthGuard(router, authenticationService) {
            this.router = router;
            this.authenticationService = authenticationService;
        }
        OAuthGuard.prototype.canLoad = function () {
            return this.authenticationService.login(null, null).pipe(operators.map(function (user) {
                if (!user) {
                    window.location.href = './';
                    return false;
                }
                return true;
            }));
        };
        OAuthGuard.prototype.canActivate = function () {
            return this.authenticationService.login(null, null).pipe(operators.map(function (user) {
                if (!user) {
                    window.location.href = './';
                    return false;
                }
                return true;
            }));
        };
        OAuthGuard.ctorParameters = function () { return [
            { type: router.Router },
            { type: commons.AuthenticationService }
        ]; };
        OAuthGuard.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function OAuthGuard_Factory() { return new OAuthGuard(core.ɵɵinject(router.Router), core.ɵɵinject(commons.AuthenticationService)); }, token: OAuthGuard, providedIn: "root" });
        OAuthGuard = __decorate([
            core.Injectable({
                providedIn: 'root'
            }),
            __metadata("design:paramtypes", [router.Router,
                commons.AuthenticationService])
        ], OAuthGuard);
        return OAuthGuard;
    }());

    var ResourceAuthGuard = /** @class */ (function () {
        function ResourceAuthGuard(authorizationService, notificationService, translate) {
            this.authorizationService = authorizationService;
            this.notificationService = notificationService;
            this.translate = translate;
        }
        ResourceAuthGuard.prototype.canActivate = function (route, state) {
            var _this = this;
            var key = 'program';
            var program = route.data[key];
            if (!program) {
                this.notificationService.showMessage(this.translate.instant('security.message.error.parameter', { parameter: key }), this.translate.instant('security.message.error.title'), commons.NotificationType.error);
                return rxjs.throwError(this.translate.instant('security.message.error.parameter.not.found', { parameter: key }));
            }
            return this.authorizationService.authorize(program).pipe(operators.map(function (data) {
                if (!data || data.length === 0) {
                    _this.notificationService.showMessage(_this.translate.instant('message.error.resource.authorization'), _this.translate.instant('title.error'), commons.NotificationType.error);
                    return false;
                }
                var keyAuthorization = 'authorization';
                route.paramMap[keyAuthorization] = data;
                return true;
            }));
        };
        ResourceAuthGuard.ctorParameters = function () { return [
            { type: AuthorizationService },
            { type: commons.NotificationService },
            { type: core$1.TranslateService }
        ]; };
        ResourceAuthGuard.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function ResourceAuthGuard_Factory() { return new ResourceAuthGuard(core.ɵɵinject(AuthorizationService), core.ɵɵinject(commons.NotificationService), core.ɵɵinject(core$1.TranslateService)); }, token: ResourceAuthGuard, providedIn: "root" });
        ResourceAuthGuard = __decorate([
            core.Injectable({
                providedIn: 'root'
            }),
            __metadata("design:paramtypes", [AuthorizationService,
                commons.NotificationService,
                core$1.TranslateService])
        ], ResourceAuthGuard);
        return ResourceAuthGuard;
    }());

    var ByteAuthenticationService = /** @class */ (function (_super) {
        __extends(ByteAuthenticationService, _super);
        function ByteAuthenticationService(http, injector) {
            var _this = _super.call(this) || this;
            _this.http = http;
            _this.injector = injector;
            return _this;
        }
        ByteAuthenticationService.prototype.login = function (username, password) {
            var _this = this;
            return this.http.post("http://localhost:4200/users/authenticate", { username: username, password: password })
                .pipe(operators.map(function (user) {
                // store user details and jwt token in local storage to keep user logged in between page refreshes
                localStorage.setItem('currentUser', JSON.stringify(user));
                if (_this.currentUserSubject) {
                    _this.currentUserSubject.next(user);
                }
                else {
                    _this.currentUserSubject = new rxjs.BehaviorSubject(user);
                }
                _this.currentUser = _this.currentUserSubject.asObservable();
                return user;
            }));
        };
        ByteAuthenticationService.prototype.logout = function () {
            // remove user from local storage to log user out
            localStorage.removeItem('currentUser');
            localStorage.removeItem('menuInfo');
            this.currentUserSubject.next(null);
            var router$1 = this.injector.get(router.Router);
            router$1.navigate(['/login']);
            return rxjs.of();
        };
        ByteAuthenticationService.ctorParameters = function () { return [
            { type: http.HttpClient },
            { type: core.Injector }
        ]; };
        ByteAuthenticationService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function ByteAuthenticationService_Factory() { return new ByteAuthenticationService(core.ɵɵinject(http.HttpClient), core.ɵɵinject(core.INJECTOR)); }, token: ByteAuthenticationService, providedIn: "root" });
        ByteAuthenticationService = __decorate([
            core.Injectable({
                providedIn: 'root'
            }),
            __metadata("design:paramtypes", [http.HttpClient, core.Injector])
        ], ByteAuthenticationService);
        return ByteAuthenticationService;
    }(commons.AuthenticationService));

    var OAuthAuthenticationService = /** @class */ (function (_super) {
        __extends(OAuthAuthenticationService, _super);
        function OAuthAuthenticationService(http, injector) {
            var _this = _super.call(this) || this;
            _this.http = http;
            _this.injector = injector;
            return _this;
        }
        OAuthAuthenticationService.prototype.login = function (username, password) {
            var _this = this;
            return this.http.get('./service/oauth/userinfo', { withCredentials: true }).pipe(operators.map(function (response) {
                var key = 'userAuthentication';
                if (response && response[key]) {
                    var user = response[key].details.principal;
                    if (!user || user instanceof String) {
                        user = response[key].details;
                    }
                    if (!user) {
                        var router$1 = _this.injector.get(router.Router);
                        console.error('No se ha identificado el usuario registrado');
                        router$1.navigate(['/notfound']);
                        return null;
                    }
                    localStorage.setItem('currentUser', JSON.stringify(user));
                    if (_this.currentUserSubject) {
                        _this.currentUserSubject.next(user);
                    }
                    else {
                        _this.currentUserSubject = new rxjs.BehaviorSubject(user);
                    }
                    _this.currentUser = _this.currentUserSubject.asObservable();
                    return user;
                }
                else {
                    return null;
                }
            }));
        };
        OAuthAuthenticationService.prototype.logout = function () {
            localStorage.removeItem('currentUser');
            localStorage.removeItem('menuInfo');
            this.currentUserSubject.next(null);
            window.location.href = './logout';
        };
        OAuthAuthenticationService.ctorParameters = function () { return [
            { type: http.HttpClient },
            { type: core.Injector }
        ]; };
        OAuthAuthenticationService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function OAuthAuthenticationService_Factory() { return new OAuthAuthenticationService(core.ɵɵinject(http.HttpClient), core.ɵɵinject(core.INJECTOR)); }, token: OAuthAuthenticationService, providedIn: "root" });
        OAuthAuthenticationService = __decorate([
            core.Injectable({
                providedIn: 'root'
            }),
            __metadata("design:paramtypes", [http.HttpClient, core.Injector])
        ], OAuthAuthenticationService);
        return OAuthAuthenticationService;
    }(commons.AuthenticationService));

    var AuthenticationInterceptor = /** @class */ (function () {
        function AuthenticationInterceptor() {
            this.AUTH_HEADER = 'Authorization';
            this.token = 'secrettoken';
            this.refreshTokenInProgress = false;
            this.refreshTokenSubject = new rxjs.BehaviorSubject(null);
        }
        AuthenticationInterceptor.prototype.intercept = function (req, next) {
            var _this = this;
            if (!req.headers.has('Content-Type')) {
                req = req.clone({
                    headers: req.headers.set('Content-Type', 'application/json')
                });
            }
            req = this.addAuthenticationToken(req);
            return next.handle(req).pipe(operators.catchError(function (err) {
                if (err && err.status === 401) {
                    if (_this.refreshTokenInProgress) {
                        return _this.refreshTokenSubject.pipe(operators.filter(function (result) { return result !== null; }), operators.take(1), operators.switchMap(function () { return next.handle(_this.addAuthenticationToken(req)); }));
                    }
                    else {
                        _this.refreshTokenInProgress = true;
                        _this.refreshTokenSubject.next(null);
                        return _this.refreshAccessToken().pipe(operators.switchMap(function (success) {
                            _this.refreshTokenSubject.next(success);
                            return next.handle(_this.addAuthenticationToken(req));
                        }), operators.finalize(function () { return _this.refreshTokenInProgress = false; }));
                    }
                }
                else {
                    return rxjs.throwError(err);
                }
            }));
        };
        AuthenticationInterceptor.prototype.refreshAccessToken = function () {
            return rxjs.of('secret token');
        };
        AuthenticationInterceptor.prototype.addAuthenticationToken = function (request) {
            // If we do not have a token yet then we should not set the header.
            // Here we could first retrieve the token from where we store it.
            if (!this.token) {
                return request;
            }
            // If you are calling an outside domain then do not add the token.
            if (!request.url.match(/localhost:4200\//)) {
                return request;
            }
            return request.clone({
                headers: request.headers.set(this.AUTH_HEADER, 'Bearer ' + this.token)
            });
        };
        AuthenticationInterceptor = __decorate([
            core.Injectable()
        ], AuthenticationInterceptor);
        return AuthenticationInterceptor;
    }());

    var AuthorizationInterceptor = /** @class */ (function () {
        function AuthorizationInterceptor() {
        }
        AuthorizationInterceptor.prototype.intercept = function (req, next) {
            return next.handle(req).pipe(operators.catchError(function (error) {
                return rxjs.throwError(error);
            }));
        };
        AuthorizationInterceptor = __decorate([
            core.Injectable(),
            __metadata("design:paramtypes", [])
        ], AuthorizationInterceptor);
        return AuthorizationInterceptor;
    }());

    var users = [{ username: 'test', password: 'test', firstName: 'Test', lastName: 'User' }];
    var AuthenticationFakeBackendInterceptor = /** @class */ (function () {
        function AuthenticationFakeBackendInterceptor() {
        }
        AuthenticationFakeBackendInterceptor.prototype.intercept = function (request, next) {
            var url = request.url, method = request.method, headers = request.headers, body = request.body;
            return rxjs.of(null)
                .pipe(operators.mergeMap(handleRoute))
                .pipe(operators.materialize())
                .pipe(operators.delay(500))
                .pipe(operators.dematerialize());
            function handleRoute() {
                switch (true) {
                    case url.endsWith('/users/authenticate') && method === 'POST':
                        return authenticate();
                    case url.endsWith('/users') && method === 'GET':
                        return getUsers();
                    default:
                        // pass through any requests not handled above
                        return next.handle(request);
                }
            }
            function authenticate() {
                var username = body.username, password = body.password;
                var user = users.find(function (x) { return x.username === username && x.password === password; });
                if (!user) {
                    return error('Username or password is incorrect');
                }
                return ok({
                    username: user.username,
                    firstName: user.firstName,
                    lastName: user.lastName,
                    token: 'fake-jwt-token'
                });
            }
            function getUsers() {
                if (!isLoggedIn()) {
                    return unauthorized();
                }
                return ok(users);
            }
            // helper functions
            function ok(bodyContent) {
                return rxjs.of(new http.HttpResponse({ status: 200, body: bodyContent }));
            }
            function error(message) {
                return rxjs.throwError({ error: { message: message } });
            }
            function unauthorized() {
                return rxjs.throwError({ status: 401, error: { message: 'Unauthorised' } });
            }
            function isLoggedIn() {
                return headers.get('Authorization') === 'Bearer fake-jwt-token';
            }
        };
        AuthenticationFakeBackendInterceptor = __decorate([
            core.Injectable()
        ], AuthenticationFakeBackendInterceptor);
        return AuthenticationFakeBackendInterceptor;
    }());

    var basePath = './service/authorize';
    var data = ['new', 'view', 'delete', 'edit', 'export'];
    var AuthorizationFakeBackendInterceptor = /** @class */ (function () {
        function AuthorizationFakeBackendInterceptor() {
        }
        AuthorizationFakeBackendInterceptor.prototype.intercept = function (request, next) {
            var url = request.url, method = request.method, headers = request.headers, body = request.body;
            return rxjs.of(null)
                .pipe(operators.mergeMap(handleRoute))
                .pipe(operators.materialize())
                .pipe(operators.dematerialize());
            function handleRoute() {
                switch (true) {
                    case url.endsWith(basePath) && method === 'POST':
                        return authorize();
                    default:
                        // pass through any requests not handled above
                        return next.handle(request);
                }
            }
            function authorize() {
                return ok(data);
            }
            // helper functions
            function ok(bodyContent) {
                return rxjs.of(new http.HttpResponse({ status: 200, body: bodyContent }));
            }
            function error(message) {
                return rxjs.throwError({ error: { message: message } });
            }
        };
        AuthorizationFakeBackendInterceptor = __decorate([
            core.Injectable()
        ], AuthorizationFakeBackendInterceptor);
        return AuthorizationFakeBackendInterceptor;
    }());

    var programsData = [
    	"CUSTOMER",
    	"COUNTRY",
    	"SYSTEM_SETTINGS",
    	"USER_ROLE",
    	"USER",
    	"system_settings_information",
    	"system_settings_password",
    	"system_settings_userpolicy",
    	"VALPOS",
    	"APPLICATION",
    	"HOBBY",
    	"TAGS",
    	"COMMISSSIONS"
    ];

    var basePath$1 = '/service/security/programs';
    var ProgramsFakeBackendInterceptor = /** @class */ (function () {
        function ProgramsFakeBackendInterceptor() {
        }
        ProgramsFakeBackendInterceptor.prototype.intercept = function (request, next) {
            var url = request.url, method = request.method, headers = request.headers, body = request.body;
            var data = programsData;
            return rxjs.of(null)
                .pipe(operators.mergeMap(handleRoute))
                .pipe(operators.materialize())
                .pipe(operators.delay(50))
                .pipe(operators.dematerialize());
            function handleRoute() {
                switch (true) {
                    case url.match('.*' + basePath$1) && method === 'GET':
                        return getList();
                    default:
                        // pass through any requests not handled above
                        return next.handle(request);
                }
            }
            function getList() {
                return ok(data);
            }
            // helper functions
            function ok(bodyContent) {
                return rxjs.of(new http.HttpResponse({ status: 200, body: bodyContent }));
            }
            function error(message) {
                return rxjs.throwError({ error: { message: message } });
            }
        };
        ProgramsFakeBackendInterceptor = __decorate([
            core.Injectable()
        ], ProgramsFakeBackendInterceptor);
        return ProgramsFakeBackendInterceptor;
    }());

    var controlsData = [
    	"new",
    	"view",
    	"edit",
    	"delete",
    	"export",
    	"audit"
    ];

    var basePath$2 = '/service/security/controls';
    var ControlsByProgramsFakeBackendInterceptor = /** @class */ (function () {
        function ControlsByProgramsFakeBackendInterceptor() {
        }
        ControlsByProgramsFakeBackendInterceptor.prototype.intercept = function (request, next) {
            var url = request.url, method = request.method, headers = request.headers, body = request.body;
            var data = controlsData;
            return rxjs.of(null)
                .pipe(operators.mergeMap(handleRoute))
                .pipe(operators.materialize())
                .pipe(operators.delay(50))
                .pipe(operators.dematerialize());
            function handleRoute() {
                switch (true) {
                    case url.indexOf(basePath$2) > -1 && method === 'GET':
                        return getList();
                    default:
                        // pass through any requests not handled above
                        return next.handle(request);
                }
            }
            function getList() {
                return ok(data);
            }
            // helper functions
            function ok(bodyContent) {
                return rxjs.of(new http.HttpResponse({ status: 200, body: bodyContent }));
            }
            function error(message) {
                return rxjs.throwError({ error: { message: message } });
            }
        };
        ControlsByProgramsFakeBackendInterceptor = __decorate([
            core.Injectable()
        ], ControlsByProgramsFakeBackendInterceptor);
        return ControlsByProgramsFakeBackendInterceptor;
    }());

    exports.AuthGuard = AuthGuard;
    exports.AuthenticationFakeBackendInterceptor = AuthenticationFakeBackendInterceptor;
    exports.AuthenticationInterceptor = AuthenticationInterceptor;
    exports.AuthorizationFakeBackendInterceptor = AuthorizationFakeBackendInterceptor;
    exports.AuthorizationInterceptor = AuthorizationInterceptor;
    exports.AuthorizationResolver = AuthorizationResolver;
    exports.AuthorizationResource = AuthorizationResource;
    exports.AuthorizationService = AuthorizationService;
    exports.ByteAuthenticationService = ByteAuthenticationService;
    exports.ControlsByProgramsFakeBackendInterceptor = ControlsByProgramsFakeBackendInterceptor;
    exports.LoginComponent = LoginComponent;
    exports.OAuthAuthenticationService = OAuthAuthenticationService;
    exports.OAuthGuard = OAuthGuard;
    exports.ProgramsFakeBackendInterceptor = ProgramsFakeBackendInterceptor;
    exports.ResourceAuthGuard = ResourceAuthGuard;
    exports.XdfSecurityModule = XdfSecurityModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=xdf-security.umd.js.map
