import { OnInit } from '@angular/core';
import { MatDialogRef } from '@angular/material';
import { NotificationService } from '@xdf/commons';
import { TranslateService } from '@ngx-translate/core';
export interface ChangeSecretDialogData {
    id: number;
    service: any;
}
export declare class ChangeSecretDialogComponent implements OnInit {
    dialogRef: MatDialogRef<ChangeSecretDialogComponent>;
    dataDialog: ChangeSecretDialogData;
    protected notificationservice: NotificationService;
    protected translateService: TranslateService;
    id: any;
    service: any;
    disabledButton: boolean;
    constructor(dialogRef: MatDialogRef<ChangeSecretDialogComponent>, dataDialog: ChangeSecretDialogData, notificationservice: NotificationService, translateService: TranslateService);
    ngOnInit(): void;
    change(): void;
    closeDialog(): void;
    onKeyUp(): void;
}
