import { ViewContainerRef } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { DynaDataService } from '../services/dyna-data.service';
import { GridTemplate } from '../../../template/grid.template';
import { ColumnTemplate } from '../../../template/column.template';
import { ConfirmationDialogService } from '../../dialogs/confirmation-dialog/services/confirmation-dialog.service';
import { AuthorizationService } from '@xdf/security';
import { NotificationService, InitCommonsService } from '@xdf/commons';
import { CrudDirective } from '../crud.directive';
import { TranslateService } from '@ngx-translate/core';
export declare class CrudGridComponent extends CrudDirective {
    protected route: ActivatedRoute;
    protected router: Router;
    dynaDataService: DynaDataService;
    protected translate: TranslateService;
    protected confirmationDialogService: ConfirmationDialogService;
    protected vcRef: ViewContainerRef;
    protected notificationService: NotificationService;
    protected authorizationService: AuthorizationService;
    protected init: InitCommonsService;
    columnTemplateArray: ColumnTemplate[];
    template: GridTemplate;
    title: string;
    sortColumn: any;
    sortDirection: any;
    innerContent: any;
    constructor(route: ActivatedRoute, router: Router, dynaDataService: DynaDataService, translate: TranslateService, confirmationDialogService: ConfirmationDialogService, vcRef: ViewContainerRef, notificationService: NotificationService, authorizationService: AuthorizationService, init: InitCommonsService);
    protected loadSettings(): void;
}
