import { Attribute } from './model/attribute';
import { AttributeType } from './model/attribute-type';
import { Validator } from './model/validator';
import { ValueOption } from './model/form';
import { ControlType } from './model/control-type';
export declare class ControlTemplate {
    id: string;
    viewID: string;
    type: AttributeType;
    controlType: ControlType;
    label: string;
    placeholder: string;
    aliasName: string;
    suggest: string;
    options: object;
    validators: Validator[];
    values: ValueOption[];
    defaultValue: any;
    required: boolean;
    styleClass: string;
    constructor(viewID: string, attribute: Attribute);
    private calcValue;
}
