export declare enum ExportOption {
    xls = "xls",
    pdf = "pdf"
}
export declare class Column {
    name: string;
    sortable: boolean;
    style: {};
    optional: boolean;
    filter: boolean;
    responsive: string;
    colStyle: string;
}
export declare class Grid {
    sortColumnDefault: string;
    sortColumnDirection: string;
    pagingSize: number;
    expandRow: boolean;
    export: ExportOption[];
    columns: Column[];
    width: string[];
    additionalColumns: string[];
    filters: string[];
}
