import { Observable } from 'rxjs';
import { HttpClient } from '@angular/common/http';
import { Pagination } from '@xdf/commons';
import { DataService } from './data.service';
export declare class DynaDataService extends DataService {
    private http;
    constructor(http: HttpClient);
    getResultPagination(pagination: Pagination): Observable<Pagination>;
    export(pagination: Pagination, type: string, definitionFile: string): Observable<any>;
    getResultList(serviceURL?: string): Observable<any>;
    search(serviceURL: string, value: any): Observable<any>;
    getResult(id: any): Observable<object>;
    getResultFromURL(serviceURL: string, id: any): Observable<object>;
    create(data: any): Observable<object>;
    update(id: any, data: any): Observable<object>;
    delete(id: any): Observable<object>;
    validateField(value: any, path: string, serviceURL: string): Observable<object>;
    getAuditData(auditData: any): Observable<object>;
}
