import { OnInit, EventEmitter } from '@angular/core';
import { ControlType } from '../../../template/model/control-type';
import { FormGroupUtils } from '../../../utils/form-group-utils';
export declare class CheckboxComponent implements OnInit {
    private formGroupUtils;
    name: string;
    type: ControlType;
    suggest: string;
    disabled: boolean;
    label: string;
    options: any;
    formGroup: any;
    onChange: EventEmitter<boolean>;
    constructor(formGroupUtils: FormGroupUtils);
    ngOnInit(): void;
    change($event: any): void;
}
