import { OnInit, OnChanges, SimpleChanges } from '@angular/core';
import { ValidatorUtils } from '../../../utils/validator-utils';
import { FormGroupUtils } from '../../../utils/form-group-utils';
export declare class DatePickerComponent implements OnInit, OnChanges {
    private formGroupUtils;
    private validatorUtils;
    name: string;
    placeholder: string;
    suggest: string;
    disabled: boolean;
    required: boolean;
    label: string;
    options: any;
    formGroup: any;
    minDate: Date;
    maxDate: Date;
    constructor(formGroupUtils: FormGroupUtils, validatorUtils: ValidatorUtils);
    ngOnChanges(changes: SimpleChanges): void;
    ngOnInit(): void;
    myFilter: (d: Date) => boolean;
    getErrors(): any[];
}
