import { OnInit } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { ValidatorUtils } from '../../../utils/validator-utils';
import { FormGroupUtils } from '../../../utils/form-group-utils';
export declare class TimePickerComponent implements OnInit, ControlValueAccessor {
    private formGroupUtils;
    private validatorUtils;
    name: string;
    placeholder: string;
    suggest: string;
    disabled: boolean;
    required: boolean;
    label: string;
    options: any;
    formGroup: any;
    private _value;
    registerOnChange(fn: (_: any) => void): void;
    registerOnTouched(fn: () => void): void;
    constructor(formGroupUtils: FormGroupUtils, validatorUtils: ValidatorUtils);
    ngOnInit(): void;
    value: any;
    writeValue(value: any): void;
    onChange: (_: any) => void;
    onTouched: () => void;
    getErrors(): any[];
}
