import { OnInit, OnChanges, SimpleChanges } from '@angular/core';
import { FormBuilder } from '@angular/forms';
import { FormGroupUtils } from '../../../utils/form-group-utils';
export declare class ToggleGroupComponent implements OnInit, OnChanges {
    private formGroupUtils;
    private formBuilder;
    label: string;
    values: [];
    name: string;
    suggest: string;
    disabled: boolean;
    required: boolean;
    options: any;
    formGroup: any;
    formArray: any;
    formArrayGroup: any;
    constructor(formGroupUtils: FormGroupUtils, formBuilder: FormBuilder);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    private mapToCheckboxArrayGroup;
}
