import { ViewContainerRef, OnInit } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { AuthorizationService } from '@xdf/security';
import { NotificationService } from '@xdf/commons';
import { ColumnTemplate } from '../../template/column.template';
import { GridTemplate } from '../../template/grid.template';
import { DynaDataService } from '../crud/services/dyna-data.service';
import { ConfirmationDialogService } from '../dialogs/confirmation-dialog/services/confirmation-dialog.service';
import { Definition } from '../../template/model/definition';
import { TranslateService } from '@ngx-translate/core';
export declare class GridViewComponent implements OnInit {
    protected route: ActivatedRoute;
    protected router: Router;
    dynaDataService: DynaDataService;
    private translate;
    protected confirmationDialogService: ConfirmationDialogService;
    protected vcRef: ViewContainerRef;
    protected notificationService: NotificationService;
    protected authorizationService: AuthorizationService;
    columnTemplateArray: ColumnTemplate[];
    resourceAuth: Object;
    serviceURL: string;
    templateDefinition: Definition;
    template: GridTemplate;
    identifier: string;
    recordId: string;
    title: string;
    sortColumn: any;
    sortDirection: any;
    innerContent: any;
    constructor(route: ActivatedRoute, router: Router, dynaDataService: DynaDataService, translate: TranslateService, confirmationDialogService: ConfirmationDialogService, vcRef: ViewContainerRef, notificationService: NotificationService, authorizationService: AuthorizationService);
    ngOnInit(): void;
}
